var m_1579527945473Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>OAuth 2.0 scopes<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1579527945473\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">OAuth 2.0 scopes<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945473_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945473_N1000B\">The purpose of OAuth 2.0 scopes is to limit the access rights granted to an OAuth client through an access token.<\/p><p class=\"par\" id=\"1579527945473_N1000F1721744831855\">The following diagram should explain, how an authorization server decides what scopes to present to a user for consent:  <\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1579527945473_N10013\"><img alt=\"ScopeProcessing\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/05_Media\/Vector_drawings\/IAM\/35249.ScopeProcessing.theme\/1.0\/en-us.35249.ScopeProcessing_original.svg\" style=\"width:;height:513px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">The AS supports the following sources for scopes:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The client requests a set of scopes when starting an authorization code flow or grant.<\/li><li class=\"enum-element\">In the static client configuration of the AS, a list of <span class=\"dialog\">Allowed\/Default Scopes<\/span> can be configured. In combination with the <span class=\"dialog\">Filter Requested Scopes<\/span> property, this is either interpreted as a filter against client-requested scopes or a default value to override client-supplied scopes.<\/li><li class=\"enum-element\">During registration using DCR a set of scopes can be registered and stored with the client.<\/li><li class=\"enum-element\">In the static client configuration of the AS or in the authorization code flow\/grant, a list of <span class=\"dialog\">Always Granted Scopes<\/span> can be configured. This list is not affected by AS policies or filtering or user local consent choices<\/li><\/ul><li class=\"step\">The AS can be configured with <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">a policy that decides how the different sources for scopes are processed. <\/li><li class=\"enum-element\">a filtering configuration that is applied to the selected source of scopes. <\/li><\/ul><li class=\"step\">In the local consent step of the authentication flow, the user will be presented with a form that <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">presents the user with a list of all the scopes the AS has been configured to accept from the different sources after applying policies and filters.<\/li><li class=\"enum-element\">requires the user to decide whether a scope is granted or denied.<\/li><li class=\"enum-element\">persists the user\'s decision regarding the scopes. <\/li><li class=\"enum-element\">will only be shown again, if there is at least one scope that has not been decided (this may be a new scope or a scope that has been deleted by an administrator).<\/li><li class=\"enum-element\">will never ask the user for consent on <span class=\"dialog\">Always Granted Scopes<\/span>.<\/li><\/ul><li class=\"step\">During the final processing of the authorization code flow\/grant, the following steps are executed: <\/li><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 Numeric\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">the list of <span class=\"dialog\">Always Granted Scopes<\/span> is added to the user-consented scopes. <\/li><li class=\"step\">Claims are generated and <span class=\"dialog\">Claim Conditions<\/span> are applied<\/li><li class=\"step\">the <span class=\"dialog\">Granted Scope Processors<\/span> configuration is applied to generate the scope claim<\/li><li class=\"step\">access, ID, and refresh tokens are issued.<\/li><\/ol><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945473_N10027\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Scope policies<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945473_N1002A\">The  <span class=\"dialog\">Scope Policy<\/span> property is configured for an authorization code flow\/grant and applies to all clients (static and dynamic) using it.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">There are 4 scope policies available:<\/strong><\/li><li class=\"enum-element\"><i class=\"italics\">Scopes Mandatory<\/i> \u2013  the request must contain at least one scope in addition to the scope <code class=\"codeinline\">openid<\/code>. Otherwise, the request is denied. <\/li><li class=\"enum-element\"><i class=\"italics\">Empty Scopes Allowed<\/i> \u2013  it is optional for the client to request scopes other than <code class=\"codeinline\">openid<\/code>.<\/li><li class=\"enum-element\"><i class=\"italics\">Always Overwrite Scopes<\/i> \u2013 the scopes requested by the client are ignored and replaced by the scopes from the <span class=\"dialog\">Allowed\/Default Scopes<\/span> list. If the client has no default scopes, this is treated as if the client has not requested any scopes.<\/li><li class=\"enum-element\"><i class=\"italics\">Empty Scopes Overwritten<\/i> \u2013 when the client does not request any scopes other than <code class=\"codeinline\">openid<\/code>, the request is treated as if the scopes from the <span class=\"dialog\">Allowed\/Default Scopes<\/span> list were requested.<\/li><p class=\"par\" id=\"1639690251641_N10050\">See the IAM plugin documentation for full details of the scope policy configuration.<\/p><\/ul><p class=\"par\" id=\"1579527945473_N1012A\">For configuration examples, see article <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1639690251641.html\">Scope configuration in IAM flows<\/a>.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945473_N1004C1640851417965\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Scope translator<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1579527945473_N1004F\">Scopes are presented to the user when granting consent is required. Airlock IAM allows for multi-language, user-friendly explanations of access rights using a scope translator.<\/p><ol class=\"enum-enum-instruction container-enum enum-standard Alpha\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To support human-readable scopes, two translation mechanisms are provided:<\/strong><\/li><li class=\"enum-element\">Server-side translation, where the translations are configured on the server.<\/li><li class=\"enum-element\">Client-side translations where the client will provide the translations. If the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp UI<\/span> is used, the <span class=\"include-text\" data-objid=\"1587054503497\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">Loginapp Design Kit<\/span> can manage the client-side translations.<\/li><\/ol><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The Loginapp UI displays scopes based on the following rule: <\/strong><\/li><li class=\"step\">Use server-side translated scope (configuration) if present.<\/li><li class=\"step\">Use client-side translated scope if present.<\/li><li class=\"step\">Use technical scope name.<\/li><\/ol><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1579527945473_N10065\">If scopes change often, server-side translation is preferable because deploying new translations on clients tends to be more costly. <\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1579527945473_N10049\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\">Configuration article <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1639690251641.html\">Scope configuration in IAM flows<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945458.html\">Supported OAuth\/OIDC Features<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';