var m_1583435024903Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>One-Touch authentication<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1583435024903\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-theme-ct\"><div class=\" headline-theme-content\"><h1 class=\" headline-theme\">Use case<\/h1><\/div><\/div><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">One-Touch authentication<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435024903_N1000B\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1583435024903_N1000C\">This article explains on a conceptual level how Airlock 2FA One-Touch authentication works. It also provides important detail information for correct use and configuration.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435024903_N10070\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Goal<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Understand One-Touch authentication in general.<\/li><li class=\"enum-element\">Understand the interaction between involved components.<\/li><li class=\"enum-element\">Learn details about prerequisites and limitations of One-Touch.<\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435071722_N10083\">All following procedures are exemplary and will vary according to your setup or needs.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435024903_N1003F\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Initial thoughts<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1583435024903_N10042\">One-Touch authentication combines excellent usability with high security. It relies on pushing information to the user\'s smartphone and signing it using cryptographic key material stored in the mobile phone\'s secure storage.<\/p><p class=\"par\" id=\"1583435024903_N10065\">The user confirms the authentication by opening the Airlock 2FA app from the push notification and then pressing the <span class=\"dialog\">Approve<\/span> button. This step may be combined with additional fingerprint scanning, face recognition, or a PIN, depending on the capabilities, and setup of the smartphone and the authenticator app.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435067227_N10056\">Airlock 2FA also supports other types of authentication. Please inform yourself about the authentication capabilities and compare them with respect to your requirements. For further information, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1585668112711.html\">Authentication factors<\/a>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435024903_N1006B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">User account exists in IAM.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The user has Airlock 2FA enabled as a possible authentication method.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">One-Touch is enabled in the Airlock 2FA configuration.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The user has installed the Airlock 2FA app on the smartphone.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The user\'s smartphone is connected to the internet and is able to connect to the Futurae cloud.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435024903_N100F1\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">One-Touch authentication flow<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1583435024903_N100F4\">The following flow chart shows how One-Touch authentication works in general:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1583435024903_N10092\"><img alt=\"UC-OneTouch-DrawIOImport\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/05_Media\/Vector_drawings\/Airlock_2FA\/35158.UC-OneTouch-DrawIOImport.theme\/1.0\/en-us.35158.UC-OneTouch-DrawIOImport_original.svg\" style=\"width:;height:674px;border:0;\"\/><\/div><\/figure><table border=\"0\" cellspacing=\"0\" class=\"table-NoBorder table table-Nolines table-Nolines table- table-block-description table-\" id=\"1583435024903_N1009F\"><col style=\"width:5%;\"\/><col style=\"width:95%;\"\/><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N100B1\">(1)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N100B4\"><span class=\"include-text\" data-objid=\"1582547575616\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">The user is identified by IAM (e.g., by entering username and password in the browser).<\/span><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N100B5\"><span class=\"include-text\" data-objid=\"1582547575616\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">If multiple Airlock 2FA apps or hardware tokens have been activated for the user, either a selection page is shown or all Airlock 2FA apps receive a push notification simultaneously. The latter happens when the <span class=\"dialog\">Push-to-All<\/span> setting is enabled.<\/span><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N100DD\">(2)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N100BF1583421751155\">IAM initiates One-Touch by showing a corresponding page in the browser and starting the authentication on the Futurae cloud.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N100E9\">(3)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N100C51583421751155\">The Futurae cloud sends a push message to the Airlock 2FA app.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N100F5\">(4)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N100CB\">The Airlock 2FA app asks the user to approve (or deny) the authentication step.<\/p><p class=\"par\" id=\"1583435024903_N100E0\">The smartphone must be unlocked. Depending on the smartphone\'s capabilities and setup, this may involve a PIN, fingerprint, or face recognition.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In this step, the user may alternatively change to an offline authentication factor (Offline QR code or passcode) if enabled in the configuration.<\/li><\/ul><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N10109\">(5)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N100DF\">The Airlock 2FA app sends the user\'s decision (approval, denial) to the Futurae cloud. The Futurae cloud receives this authentication result and forwards it to Airlock IAM.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N10115\">(6)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N100E5\"><span class=\"include-text\" data-objid=\"1582547575616\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM automatically redirects the user\'s browser to the intended target application or service.<\/span><\/p><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435024903_N10156\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Login ID<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1583435024903_N10159\">The One-Touch login ID is an additional authentication element of the One-Touch authentication factor. The login ID is a random ID generated during the One-Touch authentication procedure. The ID is shown to the authenticating user both on the application login page and on the Airlock 2FA app screen (see the next screenshot). This allows the user to verify that the push message in the app corresponds with their login session to the application.<\/p><p class=\"par\" id=\"1583435024903_N1015B\">This feature is enabled by default.<\/p><table border=\"0\" cellspacing=\"0\" class=\"table-NoBorder table table-Nolines table-Nolines table- table-block-description table-\" id=\"1583435024903_N1015B1724938759271\"><col style=\"width:65%;\"\/><col style=\"width:35%;\"\/><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-col-odd-Nolines\"><div><figure class=\"media\"><div class=\"media-theme\" id=\"1583435024903_N1015E\"><img alt=\"Airlock2FA_loginID\" class=\"media-theme-img-tag png\" src=\"..\/media\/05_Media\/Screenshots\/IAM\/Airlock_2FA\/Airlock2FA_loginID.theme\/1.1\/en-us.Airlock2FA_loginID_html.png\" style=\"width:1024px;height:528.5790476190476px;border:0;\"\/><\/div><\/figure><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-even-Nolines\"><div><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435024903_N10169\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">One-Touch with multi-numbered challenge<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1583435024903_N1016C\">To enhance the security of the One-Touch authentication, you can extend it with the <i class=\"italics\">multi-numbered challenge<\/i> solution. In this case, the user must not only approve the push message on their Airlock 2FA app but also choose the correct number from the list of numbers shown on the app screen. The correct number is the one corresponding with the number shown on the application login page. See also the next screenshot:<\/p><table border=\"0\" cellspacing=\"0\" class=\"table-NoBorder table table-Nolines table-Nolines table- table-block-description table-\" id=\"1583435024903_N1018B\"><col style=\"width:65%;\"\/><col style=\"width:35%;\"\/><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-col-odd-Nolines\"><div><figure class=\"media\"><div class=\"media-theme\" id=\"1583435024903_N10178\"><img alt=\"Airlock2FA_MultiNumberedChallenge\" class=\"media-theme-img-tag png\" src=\"..\/media\/05_Media\/Screenshots\/IAM\/Airlock_2FA\/Airlock2FA_MultiNumberedChallenge.theme\/1.1\/en-us.Airlock2FA_MultiNumberedChallenge_html.png\" style=\"width:1024px;height:722.8681481481481px;border:0;\"\/><\/div><\/figure><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-even-Nolines\"><div><\/div><\/td><\/tr><\/tbody><\/table><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435024903_N10332\">Ensure that the SDK or white-label app supports the multi-numbered challenge feature. The Airlock 2FA app supports the feature as of version 1.4.2 (Android)\/1.3.0(iOS). If you work with a custom or white-label app, the Futurae SDK version used must be 3.0 or higher.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1583435024903_N101D5\">Note that the feature requires an advanced Airlock 2FA subscription.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1583435024903_N101C4\"><strong class=\"emphasis\">Why use the multi-numbered challenge feature?<\/strong><\/p><p class=\"par\" id=\"1583435024903_N101C7\">The multi-numbered challenge feature helps protect against multi-factor authentication (MFA) fatigue attacks. This is a cyberattack where attackers possessing the victim\'s login credentials for an application repeatedly trigger authentication notifications to the victim\u2019s second-factor device. The goal is to confuse and annoy the victim into approving at least one notification, thereby granting the attacker access to the victim\'s application account. <\/p><p class=\"par\" id=\"1583435024903_N101C9\">By adding a multi-numbered challenge step to the authentication based on push notifications, the user must <i class=\"italics\">actively<\/i> select a number on the authenticator app. This prevents users from instinctively approving a push notification during an MFA attack. <\/p><p class=\"par\" id=\"1583435024903_N101CE\">The multi-numbered challenge feature replaces the login ID authentication element described previously. The login ID allows passive behavior: The user can still authenticate even if they do <i class=\"italics\">not<\/i> check the ID. This is not possible with the multi-numbered challenge feature: Here, the user <i class=\"italics\">must<\/i> select the correct number to complete the authentication successfully. This feature therefore provides a higher level of security.<\/p><p class=\"par\" id=\"1583435024903_N101D6\"><strong class=\"emphasis\">Multi-numbered challenge-based authentication flow<\/strong><\/p><p class=\"par\" id=\"1583435024903_N101DA\">The following flow chart shows how One-Touch authentication with multi-numbered challenge works. This flow equals the One-Touch authentication flow described earlier in this article, with a few additional steps. These additional steps are green in the flow chart below:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1583435024903_N101DF\"><img alt=\"2FA_OneTouch-MultiNumbered-Challenge\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/05_Media\/Vector_drawings\/Airlock_2FA\/35159.2FA_OneTouch-MultiNumbered-Challenge.theme\/1.1\/en-us.35159.2FA_OneTouch-MultiNumbered-Challenge_original.svg\" style=\"width:;height:674px;border:0;\"\/><\/div><\/figure><table border=\"0\" cellspacing=\"0\" class=\"table-NoBorder table table-Nolines table-Nolines table- table-block-description table-\" id=\"1583435024903_N101EB\"><col style=\"width:5%;\"\/><col style=\"width:95%;\"\/><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N10200\">(1)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N10207\"><span class=\"include-text\" data-objid=\"1582547575616\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">The user is identified by IAM (e.g., by entering username and password in the browser).<\/span><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N1021F\"><span class=\"include-text\" data-objid=\"1582547575616\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">If multiple Airlock 2FA apps or hardware tokens have been activated for the user, either a selection page is shown or all Airlock 2FA apps receive a push notification simultaneously. The latter happens when the <span class=\"dialog\">Push-to-All<\/span> setting is enabled.<\/span><\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N10236\">(2)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N1023D\">IAM starts the authentication process on the Futurae cloud.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N10246\">(3)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N1024D\">The Futurae cloud responds with a multi-numbered challenge value.<\/p><p class=\"par\" id=\"1583435024903_N102561725286164791\">IAM initiates the \"One-Touch with multi-numbered challenge\" process by showing a corresponding page in the browser. This page includes the value of the multi-numbered challenge returned by Futurae. <\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N10256\">(4)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N1025D\">The Futurae cloud sends a push message to the Airlock 2FA app.  <\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N102711725290905178\">(5)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N10269\">The Airlock 2FA app asks the user to approve (or deny) the authentication step.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In this step, the user may alternatively change to an offline authentication factor (Offline QR code or passcode) if enabled in the configuration.<\/li><\/ul><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N1026E\">(6)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N10275\">The Airlock 2FA app sends the user\'s decision (approval, denial) to the Futurae cloud.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N10292\">(7)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N10297\">The Futurae cloud receives this authentication result. When the user approves this first step, Futurae will send a list of (3) numbers to the Airlock 2FA app.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N1029D\">(8)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N102A2\">The Airlock 2FA app challenges the user to select the correct number. The correct number is the value shown on the login page in the browser.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N102A8\">(9)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N102AD\">The Airlock 2FA app sends the user\'s selection to the Futurae cloud. If the user selects the correct number, the Futurae cloud will inform Airlock IAM about the successful authentication.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1583435024903_N1027E\">(10)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1583435024903_N10285\"><span class=\"include-text\" data-objid=\"1582547575616\" data-objtype=\"doc\" data-serverid=\"JACKRABBIT\">IAM automatically redirects the user\'s browser to the intended target application or service.<\/span><\/p><\/div><\/td><\/tr><\/tbody><\/table><p class=\"par\" id=\"1583435024903_N102E1\"><strong class=\"emphasis\">Configuring One-Touch authentication with multi-numbered challenge<\/strong><\/p><p class=\"par\" id=\"1583435024903_N102E4\">The multi-numbered challenge feature is provided by Futurae. If you want to extend the One-Touch authentication with the multi-numbered challenge solution, contact the Airlock staff (<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-mailto\" href=\"mailto:order@airlock.com?subject=Airlock%202FA%20subscritption\">order@airlock.com<\/a>). They will then initiate the corresponding process at Futurae.<\/p><p class=\"par\" id=\"1583435024903_N102FA\">Additionally, disable the login ID property (for a description of this property, see further above).  Otherwise, the login ID will still be visible in the Airlock 2FA app. On the browser login page, however, only the multi-numbered challenge value is shown. This may confuse the user and impact usability.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To disable the login ID property, proceed as follows:<\/strong><\/li><li class=\"step\">The login ID property is a feature of the <i class=\"italics\">Airlock 2FA Authentication Step<\/i>. To disable the property, open the <span class=\"dialog\">Airlock 2FA Authentication Step<\/span> plugin dialog.<br\/>For this, go to<br\/><span class=\"dialog\">Loginapp &gt;&gt; Applications and Authentication &gt;&gt; <i class=\"italics\">&lt;the relevant application&gt;<\/i> &gt;&gt; Authentication Flow &gt;&gt; Steps<\/span><br\/>Navigate to the <span class=\"dialog\">Airlock 2FA Authentication Step<\/span> plugin. It depends on the configuration of your authentication flow where to find the <i class=\"italics\">Airlock 2FA Authentication Step<\/i> in the flow.<\/li><li class=\"step\">In the <span class=\"dialog\">Airlock 2FA Authentication Step<\/span> plugin dialog, disable the <span class=\"dialog\">Generate One-Touch Login ID<\/span> property (which is enabled by default).<\/li><li class=\"step\">Activate your configuration.<\/li><li class=\"step result\">You have now disabled the login ID property. The login ID is no longer generated when a user authenticates using One-Touch on the Airlock 2FA app.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1583435024903_N10084\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"> Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849712554.html\">Airlock 2FA One-Touch login - REST flow example<\/a><\/li><li class=\"enum-element\">This Airlock 2FA factor may also be used for transaction approval (requires an advanced license) and to verify user self-services.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';