var m_1589475710418Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Example - Quickstart using the embedded H2 database<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1589475710418\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Example - Quickstart using the embedded H2 database<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1589475710418_N10005\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1589475710418_N103F2\">This example shows how to quickly get started with Airlock IAM based on a Docker image and an integrated H2 database. An embedded H2 database is useful for integration work and enables seamless use of the IAM demo configuration. <\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1582547572445_N10837\">We recommend using the embedded H2 database only for demo and testing purposes. For production database use, please refer to <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945300.html\">User data source configuration (databases and directories)<\/a>.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1589475710418_N10030\">Setting up Airlock IAM with an embedded H2 database can be achieved via Docker CLI or via the <code class=\"codeinline\">docker-compose.yml<\/code> file. The required commands for both options follow in the code blocks below.<\/p><p class=\"par\" id=\"1589475710418_N10035\">There is no difference in the commands for IAM images obtained from quay.io or for IAM images obtained from Docker Hub, except for the path to the image repositories. To facilitate copy-and-paste, however, the sample code is given for both cases.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1589475710418_N10021\">In Spring 2024, all images will be migrated from Docker Hub to quay.io. All customers that use Docker Hub for container image downloads must migrate until September 2024.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1589475710418_N10037\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Embedding the H2 database with images from <i class=\"italics\">quay.io<\/i><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1589475710418_N103F4\"><strong class=\"emphasis\">Via the Docker CLI:<\/strong><\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N103F7\">docker run --rm \\\r\n  --env \"TZ=Europe\/Zurich\" \\\r\n  --env \"IAM_LOG_LEVEL=DEBUG\" \\\r\n  --env \"IAM_MODULES=adminapp,loginapp,transaction-approval,api-policy-service,service-container,h2\" \\\r\n  -v \"$(pwd)\/iam:\/home\/airlock\/iam\" \\\r\n  -p 8443:8443 \\\r\n  quay.io\/airlock\/iam:7.7<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1589475710418_N103F9\"><strong class=\"emphasis\">In the <code class=\"codeinline\">docker-compose.yml<\/code>:<\/strong><\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N103FC\">version: \'3.7\'\r\nservices:\r\n  iam:\r\n    image: quay.io\/airlock\/iam:7.7 environment:\r\n      - \"TZ=Europe\/Zurich\"\r\n      - \"IAM_LOG_LEVEL=DEBUG\"\r\n      - \"IAM_MODULES=adminapp,loginapp,transaction-approval,api-policy-service,service-container,h2\"\r\n    volumes:\r\n      - type: bind\r\n        source: \".\/iam\"\r\n        target: \"\/home\/airlock\/iam\"\r\n    ports:\r\n      - \"8443:8443\"<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1589475710418_N10064\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Embedding the H2 database with images from <i class=\"italics\">Docker Hub<\/i><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1589475710418_N10069\"><strong class=\"emphasis\">Via the Docker CLI:<\/strong><\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10075\">docker run --rm \\\r\n  --env \"TZ=Europe\/Zurich\" \\\r\n  --env \"IAM_LOG_LEVEL=DEBUG\" \\\r\n  --env \"IAM_MODULES=adminapp,loginapp,transaction-approval,api-policy-service,service-container,h2\" \\\r\n  -v \"$(pwd)\/iam:\/home\/airlock\/iam\" \\\r\n  -p 8443:8443 \\\r\n  docker.io\/ergon\/airlock-iam:7.7<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1589475710418_N1007A\"><strong class=\"emphasis\">In the <code class=\"codeinline\">docker-compose.yml<\/code>:<\/strong><\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10088\">version: \'3.7\'\r\nservices:\r\n  iam:\r\n    image: docker.io\/ergon\/airlock-iam:7.7 environment:\r\n      - \"TZ=Europe\/Zurich\"\r\n      - \"IAM_LOG_LEVEL=DEBUG\"\r\n      - \"IAM_MODULES=adminapp,loginapp,transaction-approval,api-policy-service,service-container,h2\"\r\n    volumes:\r\n      - type: bind\r\n        source: \".\/iam\"\r\n        target: \"\/home\/airlock\/iam\"\r\n    ports:\r\n      - \"8443:8443\"<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';