var m_1715877709935Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>PAR - Pushed Authorization Request on the AS\/OP<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1715877709935\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">PAR - Pushed Authorization Request on the AS\/OP<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1715877709935_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1715877709935_N10009\">Pushed Authorization Request is a standard in OAuth 2.0 and specified in <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/datatracker.ietf.org\/doc\/html\/rfc9126\" target=\"_blank\">RFC 9126 - OAuth 2.0 Pushed Authorization Requests<\/a>.<\/p><p class=\"par\" id=\"1715877709935_N1001C\">The purpose of PAR is to allow a client to push authorization request parameters directly to the authorization server. This avoids exposing these parameters to the user agent (i.e. a browser on the end-users system) and reduces the potential attack surface.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Authenticity and integrity of request parameters is ensured.<\/li><li class=\"enum-element\">Confidentiality of requests parameters is guaranteed.<\/li><li class=\"enum-element\">Potential problems with overlong request URLs are avoided.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1715877709935_N10029\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">PAR protocol<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1715877709935_N1001E\">When PAR is configured in the authorization server, the PAR endpoint will be published as  <span class=\"dialog\">pushed_authorization_request_endpoint<\/span> in the discovery document.<\/p><p class=\"par\" id=\"1715877709935_N10032\">A client sends an authenticated request to this PAR endpoint of the authorization server to register an authorization request. <\/p><p class=\"par\" id=\"1715877709935_N10035\">The authorization server responds to the client with a URI identifying the PAR request (request_uri).<\/p><p class=\"par\" id=\"1715877709935_N10040\">The client can start the authorization code flow with client_id and request_uri as the only parameters.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1715877709935_N1003E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Database storage of PAR requests<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1715877709935_N10041\">The authorization server persists the authorization request parameters from when the client pushes them until they are needed again when the user-agent starts the authorization code flow. This requires a database table called OAUTH2_PAR_REQUEST in the database. <\/p><p class=\"par\" id=\"1715877709935_N10043\">Every time an authorization code flow is started, the PAR entry in the database is deleted. It is still possible that unconsumed PAR requests accumulate in the database and a clean-up job is provided for regular housekeeping.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1715877709935_N10045\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Migration from IAM 8.2 or older<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1715877709935_N10048\">To use PAR as an authorization server, a database migration is required to add the new table. <\/p><p class=\"par\" id=\"1715877709935_N100561721309061919\">To migrate the database schema from IAM 8.2 or older, use the migration scripts provided in <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945303.html\">Relational databases for IAM<\/a>.<\/p><p class=\"par\" id=\"1715877709935_N10067\">Make sure that the OAuth 2.0 Clean-up Task is enabled since the clean-up of PAR requests is an integral part of this task.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1715877709935_N10056\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1715877709959.html\">PAR configuration for OAuth 2.0 and OIDC authorization servers<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1720717688801.html\">PAR configuration for OAuth 2.0 and OIDC Clients<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';