var m_1719909127135Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Migrating the Airlock 2FA app - Deleting only the migrated token<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1719909127135\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Migrating the Airlock 2FA app - Deleting only the migrated token<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1719909127135_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1719909127135_N10009\">This article describes how to migrate from the Airlock 2FA app to a new business app with a built-in two-factor authentication solution based on the Futurae Mobile SDK (the so-called One App solution). In this use case, only the token used for the migration is deleted.    <\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1719909127135_N1007C\">The use cases and configurations described in this article are recommendations. You can change, enhance or replace them according to your requirements.<\/p><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">In this use case:<\/strong> <\/li><li class=\"enum-element\">Three separate authentication flows are set up, to enable the use of the old business application and the new One App simultaneously (but on different devices). For more details, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1719909127135.html#1719909127135_N1041E\">Configuring the migration flows<\/a>.<\/li><li class=\"enum-element\">Upon successful activation of the new One App, the <i class=\"italics\">migrated<\/i> flag on the user\'s account is set to <i class=\"italics\">true<\/i>. Additionally, the token used for the migration is deleted. The user can no longer use this token and the old business app\/Airlock 2FA app on the device where the migration took place. However, the user can still use the old business app\/Airlock 2FA app on other devices. <\/li><li class=\"enum-element\">The end-user is prompted to migrate when they access the business application via the <i class=\"italics\">browser<\/i>. This prompt stops as soon as the user has installed and activated the new One App on one of their mobile devices.<\/li><li class=\"enum-element\">There is no prompt when users access the business application via the old business <i class=\"italics\">app<\/i> in combination with the old Airlock 2FA app. It is up to you to decide whether and how to include migration prompts when using the old business <i class=\"italics\">app<\/i>.  For more details, see section  <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1719909127135.html#1719909127135_N104D0\">Adapting the text in the login UI (prompts)<\/a>. <\/li><li class=\"enum-element\">If the end-user simultaneously employs the old business app\/Airlock 2FA and the new One App, they can no longer use the \"Open in App\" button on devices that are not yet migrated. This is because the 2FA app service will try to open the new One App. However, this new app is not available yet on a non-migrated device.  <\/li><li class=\"enum-element\">In this setup, an end-user may still access the business application in combination with the Airlock 2FA app for a long time after the new One App solution is released. This only stops when the old Airlock 2FA app is no longer supported in the 2FA app service. It is up to you to set this moment in time and to communicate this to your customers.   <\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1719909127135_N1001E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"> Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Prerequisites for configuring the migration:<\/li><li class=\"enum-element\">Your end-user database contains a \"Migrated\" column with value type Boolean. This DB column is required to prompt the end-user to migrate.<\/li><li class=\"enum-element\">The One App solution is set up such, that it can facilitate the configuration options described further below in this article.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Prerequisites for performing the migration (by the end-user):<\/li><li class=\"enum-element\">A service account for the Airlock 2FA app exists in the Futurae cloud. <\/li><li class=\"enum-element\">The end-user account exists in IAM.<\/li><li class=\"enum-element\">The end-user has Airlock 2FA enabled as a possible authentication method.<\/li><li class=\"enum-element\">The end-user has installed the Airlock 2FA app on the mobile phone.<\/li><li class=\"enum-element\">The end-user\'s mobile phone is connected to the Internet and can connect to the Airlock 2FA service in the Futurae cloud. <\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1719909127135_N10030\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Migration configuration steps<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction Numeric\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Configuring the migration process includes the following steps:<\/li><li class=\"step\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1719909127135.html#1719909127135_N10055\">Preparing for migration<\/a><\/li><li class=\"step\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1719909127135.html#1719909127135_N10117\">Adding a migrated flag to the user accounts<\/a><\/li><li class=\"step\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1719909127135.html#1719909127135_N1041E\">Configuring the migration flows<\/a><\/li><li class=\"step\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1719909127135.html#1719909127135_N104D0\">Adapting the text in the login UI (prompts)<\/a><\/li><\/ol><p class=\"par\" id=\"1719909127135_N10072\">Detailed descriptions of each step follow below.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1719909127135_N10055\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Preparing for migration<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1719909127135_N10085\">Usually, one Airlock 2FA app corresponds with one Airlock 2FA service account in the Futurae cloud. However, it is possible to use multiple apps at the same time with the same Airlock 2FA service. This is a useful feature when migrating from the Airlock 2FA app to the One App solution. Thus, the old 2FA app and the new One App can be used in parallel, by different end-users and on different devices (see also <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1592482454621.html\">Using multiple apps in one service<\/a>).<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Proceed as follows to plan the migration process:<\/strong><\/li><li class=\"step\">Contact the Airlock staff (<a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-mailto\" href=\"mailto:order@airlock.com?subject=Airlock%202FA%20custom%20app\">order@airlock.com<\/a>) and provide information on the following:  <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Request to temporarily have two 2FA apps in your Airlock service account.<\/li><li class=\"enum-element\">Required account details for the new One App solution.<\/li><div xmlns=\"\" class=\"container-warning observe compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1719909127135_N100C4\">Never share API keys.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"enum-element\">The time schedule: When to make the new app available in the service and the app stores; when and how to inform the users (e.g., via prompts, via e-mail, ...); when to remove the old app from the service; and so on. <\/li><\/ul><li class=\"step\">Upload the new One App to the prevalent app stores.<\/li><li class=\"step\">Ensure that new users will only enroll and use the new One App.<\/li><li class=\"step\">Inform the existing end-users about the introduction of and migration to the new One App. Start the information process in time. <\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1719909127135_N10117\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Adding a <i class=\"italics\">migrated<\/i> flag to the user accounts<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1719909127135_N1011A1718889362509\">This section explains how to add a <i class=\"italics\">migrated<\/i> flag to the IAM user accounts. This flag is set to <i class=\"italics\">true<\/i> as soon as the end-user migrated to the new One App solution.<\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1719909127135_N10149\">The <i class=\"italics\">migrated<\/i> flag is used to prompt an end-user to migrate to the new One App when accessing the business application via the browser. As soon as an end-user migrated to the new One App on one of their devices, the prompt disappears.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1719909127135_N1014E\">However, you may want this prompt to appear <i class=\"italics\">every time<\/i> a user uses the browser to access the business application. Or maybe you do not want to prompt your end-users at all. In these two cases, you do not need the <i class=\"italics\">migrated<\/i> flag. You can skip the instructions in this section and proceed with the configuration of the migration flows (see section <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1719909127135.html#1719909127135_N1041E\">Configuring the migration flows<\/a> below).<\/p><\/div><\/div><\/div><\/div><\/div><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Proceed as follows:<\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">MAIN SETTINGS<\/span>  &gt;&gt; <span class=\"dialog\">Data Sources<\/span> &gt;&gt; <span class=\"dialog\">User Data Source<\/span> &gt;&gt; <span class=\"dialog\">Database User Persister<\/span> <\/li><li class=\"step\">In section <span class=\"dialog\">Context Data<\/span> in the list <span class=\"dialog\">Context Data Columns<\/span>, create and edit a new <span class=\"dialog\">Boolean Context Data Item<\/span> plugin, with the <span class=\"dialog\">Boolean Context Data Item Name<\/span> plugin as <span class=\"dialog\">Context Data Name<\/span>.<\/li><li class=\"step\">In property <span class=\"dialog\">Context Data Name<\/span> of the <span class=\"dialog\">Boolean Context Data Item Name<\/span> plugin, enter <i class=\"italics\">migrated<\/i> as the name of the new Boolean context data item. Ensure that this name equals the name of the corresponding column in your user database. <\/li><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1719909127135_N1013C1720451875551\">You can in fact choose any name you like for the new Boolean context data item. The only requirement is that the name equals the name of the corresponding column in your user database.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Activate your configuration. <\/li><li class=\"step result\">The IAM user accounts now contain a new Boolean context data item\/flag. <\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1719909127135_N1041E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuring the migration flows<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">In this use case, the following three separate authentication flows are set up: <\/li><li class=\"enum-element\">One flow for the use case where an end-user has installed the new One App on their mobile phone, and is going to use\/uses it in mobile-only mode. In the mobile-only mode, both the business app and the 2FA authentication functions run on the same mobile device. This first flow has two sub-flows: One sub-flow will migrate the user to and activate the One App, the other triggers the regular mobile-only authentication for the new One App, when migration and activation is completed.<\/li><figure class=\"media\"><div class=\"media-theme\" id=\"1719909127135_N1019E1723640563357\"><img alt=\"Airlock2FA-migration-flows-option3_flow1_en-us\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/05_Media\/Vector_drawings\/Airlock_2FA\/35175.Airlock2FA-migration-flows-option3_flow1_en-us.theme\/1.2\/en-us.35175.Airlock2FA-migration-flows-option3_flow1_en-us_original.svg\" style=\"width:1024px;height:224.78048780487805px;border:0;\"\/><\/div><\/figure><li class=\"enum-element\">One flow for the use case where an end-user wants to use the old business app\/2FA app in mobile-only mode on a specific device, after they activated the new One App on another device. In this situation, the 2FA app service will always try to open the new One App for authentication. To still allow the use of the old apps, you must configure an authentication flow dedicated specifically to this use case.<\/li><figure class=\"media\"><div class=\"media-theme\" id=\"1719909127135_N101AD\"><img alt=\"Airlock2FA-migration-flows-option3_flow2_en-us\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/05_Media\/Vector_drawings\/Airlock_2FA\/35176.Airlock2FA-migration-flows-option3_flow2_en-us.theme\/1.2\/en-us.35176.Airlock2FA-migration-flows-option3_flow2_en-us_original.svg\" style=\"width:;height:117px;border:0;\"\/><\/div><\/figure><li class=\"enum-element\">The third flow represents the use case where the end-user logs in to the business application via the browser.<\/li><figure class=\"media\"><div class=\"media-theme\" id=\"1719909127135_N101BC\"><img alt=\"Airlock2FA-migration-flows-option3_flow3_en-us\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/05_Media\/Vector_drawings\/Airlock_2FA\/35177.Airlock2FA-migration-flows-option3_flow3_en-us.theme\/1.2\/en-us.35177.Airlock2FA-migration-flows-option3_flow3_en-us_original.svg\" style=\"width:1024px;height:220.07815275310836px;border:0;\"\/><\/div><\/figure><\/ul><p class=\"par\" id=\"1719909127135_N101A5\">The instructions below explain how to set up each authentication flow. There is one instruction section per authentication flow.<\/p><p class=\"par\" id=\"1719909127135_N101B3\"><\/p><p class=\"par\" id=\"1719909127135_N101B4\"><strong class=\"emphasis\"><u class=\"underline\">Flow 1A: Migration to the new One App - Mobile-only authentication<\/u><\/strong><\/p><p class=\"par\" id=\"1719909127135_N101BE\">The flow described here migrates the end-user to and activates the new One App on a specific device. The flow is triggered when the end-user logs in to the new One App for the first time after downloading the app.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1719909127135_N101D6\"><img alt=\"Airlock2FA-migration-flows-option3_flow1A_en-us\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/05_Media\/Vector_drawings\/Airlock_2FA\/35178.Airlock2FA-migration-flows-option3_flow1A_en-us.theme\/1.1\/en-us.35178.Airlock2FA-migration-flows-option3_flow1A_en-us_original.svg\" style=\"width:1024px;height:224.78048780487805px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To configure the flow, proceed as follows:<\/strong><\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span><\/li><li class=\"step\">Create a new application for mobile-only authentication with the new One App, to be used to migrate to and activate the One App. This flow is automatically triggered, if the end-user tries to log in to the One App, and the app is not activated yet.<\/li><li class=\"step\">Next, create the authentication flow for the just created application. For this, go to: <br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; <span class=\"dialog\">&lt;Your mobile-only One App business application used for migration&gt;<\/span> &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span> in the <span class=\"dialog\">Steps<\/span> list, create and edit an <span class=\"dialog\">Airlock 2FA Mobile Only Authentication Step<\/span> plugin, as follows: <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In a mobile-only situation, the 2FA app service will try to open the new One App for authentication. However, as the One App is not activated yet, the end-user can at this point only authenticate via the old Airlock 2FA app.  The <i class=\"italics\">Scheme Override<\/i> feature allows replacing the One App URI returned by the app service with the URI of the \"old\" Airlock 2FA app. For this, go to property <span class=\"dialog\">Scheme Override<\/span> in section <span class=\"dialog\">Advanced Settings<\/span> of the <span class=\"dialog\">Airlock 2FA Mobile Only Authentication Step<\/span> plugin, and enter the URI scheme of the old 2FA app, which is <i class=\"italics\">airlock2fa<\/i>.<\/li><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1719909127135_N1022E\">A URI or Uniform Resource Identifier helps identify a resource or location without ambiguity. A URI scheme refers to a specific URI format, used to specifically identify a group of resources or locations. Some examples of URI schemes are the <i class=\"italics\">https<\/i> URI scheme or the <i class=\"italics\">file<\/i> URI scheme.<br\/>In the context here, the URI scheme refers to the scheme of the <i class=\"italics\">mobile authentication URI<\/i>. It determines which app to open on the mobile device for authentication. For example, the URI scheme <i class=\"italics\">airlock2fa<\/i> refers to the Airlock 2FA app. <\/p><\/div><\/div><\/div><\/div><\/div><\/ul><li class=\"step result\">The end-user can still use the old app to log in and authenticate.<\/li><li class=\"step\">Next, configure the actual migration flow. The flow will activate the new One App.<\/li><ol class=\"enum-enum-instruction container-enum enum-standard Alpha\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Proceed as follows:<\/strong><\/li><li class=\"enum-element\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; <span class=\"dialog\">&lt;Your mobile-only One App business application used for migration&gt;<\/span> &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"enum-element\">In section <span class=\"dialog\">Basic Settings<\/span> in the <span class=\"dialog\">Steps<\/span> list, create or edit the <span class=\"dialog\">Migration Selection Step<\/span> plugin. This plugin should come after the <span class=\"dialog\">Airlock 2FA Mobile Only Authentication Step<\/span> plugin.<\/li><li class=\"enum-element\">In section <span class=\"dialog\">Basic Settings<\/span> of the <span class=\"dialog\">Migration Selection Step<\/span> plugin, create and edit a new <span class=\"dialog\">Advanced Migration Selection Option<\/span> plugin, as follows:<\/li><li class=\"enum-element\">In property <span class=\"dialog\">Option Name<\/span>, enter a relevant option name for the plugin, such as <i class=\"italics\">MIGRATE_NOW<\/i>.<\/li><li class=\"enum-element\">In property <span class=\"dialog\">Steps<\/span> of the <span class=\"dialog\">Advanced Migration Selection Option<\/span> plugin, create and edit the following <i class=\"italics\">Step<\/i> plugins. Together, these plugins build the migration flow.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><span class=\"dialog\">Airlock 2FA Activation Step<\/span> plugin, with default settings. This step will activate the new One App on the currently used device.<\/li><li class=\"enum-element\"><span class=\"dialog\">Airlock 2FA Delete Authentication Device Step<\/span> plugin, with default settings. This plugin deletes the token used to authenticate the user in the current flow.<\/li><li class=\"enum-element\"><span class=\"dialog\">Set Context Data Step<\/span> plugin. This plugin sets the <i class=\"italics\">migrated<\/i> flag to <i class=\"italics\">true<\/i> in the user\'s IAM account upon completion of the previous steps.<\/li><div xmlns=\"\" class=\"container-warning info compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1719909127135_N10286\">Users who log in to the business application via the browser are prompted to migrate as long as the <i class=\"italics\">migrated<\/i> flag is not set. However, you do not need the flag, nor the <span class=\"dialog\">Set Context Data Step<\/span> plugin, if the end-user should be prompted to migrate <i class=\"italics\">every time<\/i> they log in with the browser, or if they should not be prompted at all. In these two cases, you can skip the rest of the instructions and activate your configuration.<\/p><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Specifying the <span class=\"dialog\">Set Context Data Step<\/span> plugin<\/strong><\/li><li class=\"enum-element\">In section <span class=\"dialog\">Basic Settings<\/span> and in property <span class=\"dialog\">User Data Items<\/span>, create and edit a <span class=\"dialog\">Boolean Context Data<\/span> plugin, as follows:<\/li><li class=\"enum-element\">In property <span class=\"dialog\">Context Data Item Name Config<\/span>, select the <span class=\"dialog\">Boolean Context Data Item Name<\/span> plugin created in <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1719909127135.html#1719909127135_N10117\">Adding a migrated flag to the user accounts<\/a>. <\/li><li class=\"enum-element\">In property <span class=\"dialog\">Value Provider Config<\/span>, create a <span class=\"dialog\">Boolean Context Data Value Provider <\/span> plugin, enter a meaningful name for the plugin in the <span class=\"dialog\">Identifier<\/span> field and connect it in property <span class=\"dialog\">Context Data Field<\/span> with the <span class=\"dialog\">Boolean Context Data Item Name<\/span> plugin created in <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1719909127135.html#1719909127135_N10117\">Adding a migrated flag to the user accounts<\/a>. Additionally, enable the property <span class=\"dialog\">Mandatory<\/span>.<\/li><\/ul><\/ul><li class=\"enum-element\">Return to the <span class=\"dialog\">Advanced Migration Selection Option<\/span> plugin dialog. The plugin\'s property <span class=\"dialog\">Condition <\/span> defines the condition to start the authentication flow defined above. This is when the end-user has not migrated yet. That is, if the <i class=\"italics\">migrated<\/i> flag is not set and has value <i class=\"italics\">null<\/i> (or <i class=\"italics\">false<\/i>).<br\/>To define this condition, create and edit the <span class=\"dialog\">Boolean Condition<\/span> plugin in the <span class=\"dialog\">Condition<\/span> property field, as follows:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In property <span class=\"dialog\">Value Provider<\/span>, select the <span class=\"dialog\">Boolean Context Data Value Provider<\/span> plugin you created in the previous step.<\/li><li class=\"enum-element\">Enable the checkbox <span class=\"dialog\">Is Fulfilled If Value Is Null<\/span>.<\/li><\/ul><\/ol><li class=\"step\">Activate your configuration.<\/li><li class=\"step result\">You have now configured an authentication flow that migrates an end-user from the old business app\/Airlock 2FA to the new business app with built-in 2FA authentication. This use case only deletes the token used for authentication in the migration flow.<\/li><\/ol><p class=\"par\" id=\"1719909127135_N102E0\"><\/p><p class=\"par\" id=\"1719909127135_N102A8\"><u class=\"underline\"><strong class=\"emphasis\">Flow 1B: Regular use of the One App - Mobile-only authentication<\/strong><\/u><\/p><p class=\"par\" id=\"1719909127135_N102A1\">As soon as the end-user has migrated to and activated the new One App, they can use the app for regular mobile-only authentication. The flow described here enables the regular mobile-only authentication flow with the new One App solution.  <\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1719909127135_N1031F\"><img alt=\"Airlock2FA-migration-flows-option3_flow1B_en-us\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/05_Media\/Vector_drawings\/Airlock_2FA\/35179.Airlock2FA-migration-flows-option3_flow1B_en-us.theme\/1.1\/en-us.35179.Airlock2FA-migration-flows-option3_flow1B_en-us_original.svg\" style=\"width:1024px;height:224.78048780487805px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To configure the flow, proceed as follows:<\/strong><\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span><\/li><li class=\"step\">Create a new application for mobile-only authentication with the new One App. This flow is automatically triggered when the end-user has migrated to and activated the One App.<\/li><li class=\"step\">Next, create the authentication flow for the just created application. For this, go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; <span class=\"dialog\">&lt;Your mobile-only One App application&gt;<\/span> &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span> in the <span class=\"dialog\">Steps<\/span> list, create and edit an <span class=\"dialog\">Airlock 2FA Mobile Only Authentication Step<\/span> plugin. Use the default settings. <\/li><li class=\"step\">Activate your configuration.<\/li><li class=\"step result\">You have now created the regular mobile-only authentication flow for the new One App.<\/li><\/ol><p class=\"par\" id=\"1719909127135_N103291720596276298\"><\/p><p class=\"par\" id=\"1719909127135_N10326\"><u class=\"underline\"><strong class=\"emphasis\">Flow 2: Mobile-only authentication with the old business app<\/strong><\/u><\/p><p class=\"par\" id=\"1719909127135_N102D4\">This flow represents the use case where an end-user wants to use the old business app\/2FA app in mobile-only mode on a specific device, after they activated the new One App on another device. In this situation, the 2FA app service will always try to open the new One App for authentication. To still allow the use of the old apps, IAM introduced the <i class=\"italics\">Scheme Override<\/i> feature. This feature allows replacing the One App URI (scheme) returned by the app service with the URI (scheme) of the \"old\" Airlock 2FA. <\/p><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1719909127135_N10391\">A URI or Uniform Resource Identifier helps identify a resource or location without ambiguity. A URI scheme refers to a specific URI format, used to specifically identify a group of resources or locations. Some examples of URI schemes are the <i class=\"italics\">https<\/i> URI scheme or the <i class=\"italics\">file<\/i> URI scheme.<br\/>In the context here, the URI scheme refers to the scheme of the <i class=\"italics\">mobile authentication URI<\/i>. It determines which app to open on the mobile device for authentication. For example, the URI scheme <i class=\"italics\">airlock2fa<\/i> refers to the Airlock 2FA app. <\/p><\/div><\/div><\/div><\/div><\/div><figure class=\"media\"><div class=\"media-theme\" id=\"1719909127135_N102F5\"><img alt=\"Airlock2FA-migration-flows-option3_flow2_en-us\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/05_Media\/Vector_drawings\/Airlock_2FA\/35180.Airlock2FA-migration-flows-option3_flow2_en-us.theme\/1.2\/en-us.35180.Airlock2FA-migration-flows-option3_flow2_en-us_original.svg\" style=\"width:;height:117px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To configure the flow, proceed as follows:<\/strong><\/li><li class=\"step\">Go to: <br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; <span class=\"dialog\">&lt;Your  <i class=\"italics\">old<\/i> business app&gt;<\/span> &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span> in the <span class=\"dialog\">Steps<\/span> list, edit the <span class=\"dialog\">Airlock 2FA Mobile Only Authentication Step<\/span> plugin:<\/li><ol class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 Alpha\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Go to the property <span class=\"dialog\">Scheme Override<\/span> in section <span class=\"dialog\">Advanced Settings<\/span>.<\/li><li class=\"enum-element\">Enter <i class=\"italics\">airlock2fa<\/i>, the URI scheme of the <i class=\"italics\">old <\/i> 2FA app in the property field. This is necessary to replace the One App URI scheme, which is returned by the app service by default. <\/li><\/ol><li class=\"step\">Activate your configuration.<\/li><li class=\"step result\">The end-user can still use the old business app\/2FA app to log in and authenticate.<\/li><\/ol><p class=\"par\" id=\"1719909127135_N1037B\"><\/p><p class=\"par\" id=\"1719909127135_N1033F\"><strong class=\"emphasis\"><u class=\"underline\">Flow 3: Login via browser to the business application<\/u><\/strong><\/p><p class=\"par\" id=\"1719909127135_N10317\">This flow represents the use case where the end-user logs in to the business application via the browser and decides to migrate to the new One App, as a reaction to a prompt during login. <\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1719909127135_N10397\">To facilitate a smooth migration process, the prompt to migrate should also include a hint to download the app.<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1719909127135_N10319\">In this browser-login use case, the user is prompted to migrate as long as they have not activated the new One App on any of their mobile devices, and the <i class=\"italics\">migrated<\/i> flag is not set. If the flag is set or if the user decides to ignore the prompt, the current browser-login procedure will be completed - no migration to the new One App will take place. <\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1719909127135_N103CA\">Instead of only prompting the user when the <i class=\"italics\">migrated<\/i> flag is not set, you may want to prompt the user every time they log in with the browser. Or you may not want to prompt the users at all. It is up to you how to configure this.<\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Possible options<\/strong><\/li><li class=\"enum-element\">Prompt upon each browser login:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Use the flow described here, but without the <i class=\"italics\">migrated<\/i> flag and corresponding <span class=\"dialog\">Set Context Data Step<\/span> plugin. To configure this use case, follow the instructions below. <\/li><li class=\"enum-element\">Use the current, \"old\" authentication flow, but add a prompt upon login to download and activate the new One App.<\/li><li class=\"enum-element\">For details on configuring the prompt itself, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1719909127135.html#1719909127135_N104D0\">Adapting the text in the login UI (prompts)<\/a>.<\/li><\/ul><li class=\"enum-element\">No prompt at all:<br\/>In this case, you can continue using the current, \"old\" authentication flow without any modifications. If you still want to inform the end-users about the new One App, use any other form of communication (email, activation letter with QR code).<\/li><\/ul><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1719909127135_N103F3\"><\/p><\/div><\/div><\/div><\/div><\/div><figure class=\"media\"><div class=\"media-theme\" id=\"1719909127135_N10344\"><img alt=\"Airlock2FA-migration-flows-option3_flow3_en-us\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/05_Media\/Vector_drawings\/Airlock_2FA\/35181.Airlock2FA-migration-flows-option3_flow3_en-us.theme\/1.2\/en-us.35181.Airlock2FA-migration-flows-option3_flow3_en-us_original.svg\" style=\"width:1024px;height:220.07815275310836px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">To configure the flow, proceed as follows:<\/strong><\/li><li class=\"step\">Go to: <br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Applications and Authentication<\/span> &gt;&gt; <span class=\"dialog\">&lt;Your browser-login application&gt;<\/span> &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span> in the <span class=\"dialog\">Steps<\/span> list, create or edit the <span class=\"dialog\">Migration Selection Step<\/span> plugin. This plugin should come after the <span class=\"dialog\">Airlock 2FA Authentication Step<\/span> plugin.<\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span> of the <span class=\"dialog\">Migration Selection Step<\/span> plugin, create and edit a new <span class=\"dialog\">Advanced Migration Selection Option<\/span> plugin. For a detailed description of the plugin\'s configuration, see steps 5d, 5e, and 5f of section <i class=\"italics\">Flow 1A: Migration to the new One App - Mobile-only authentication<\/i> above. <strong class=\"emphasis\">Important<\/strong>: In step 5e, add the <span class=\"dialog\">Airlock 2FA Activation <i class=\"italics\">(with additional activation)<\/i> Step<\/span> plugin (instead of the <span class=\"dialog\">Airlock 2FA Activation Step<\/span> plugin)!<\/li><li class=\"step\">Activate your configuration.<\/li><li class=\"step result\">You have now configured an authentication flow that migrates an end-user during the browser login procedure to the new business app with built-in 2FA authentication. This use case deletes the token used for authentication when logging in to the browser.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1719909127135_N104D0\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Adapting the text in the login UI (prompts)<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1719909127135_N101E5\">The flows described above include several prompts to migrate to and activate the new One App solution. The prompt text appears in a separate window during the login processes. The text is specified in the language property files provided with Airlock IAM. For more information on how to add and\/or customize UI texts, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142516.html\">Customizing Loginapp UI texts and changing translations with the Loginapp Design Kit<\/a>. <\/p><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">The corresponding keys are:<\/li><li class=\"enum-element\"><code class=\"codeinline\">authentication.migration.methods.migrate-to-new-airlock2fa.title.caption<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">authentication.migration.methods.migrate-to-new-airlock2fa.migration-instructions<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">authentication.migration.methods.migrate-to-new-airlock2fa.next-steps-instructions<\/code><\/li><\/ul><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1719909127135_N1008E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1592482454621.html\">Using multiple apps in one service<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849683610.html\">Mobile-only authentication (app-to-app or SDK)<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1614328142516.html\">Customizing Loginapp UI texts and changing translations with the Loginapp Design Kit<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';