var m_1720717696063Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>OAuth 2.0 claims<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1720717696063\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">OAuth 2.0 claims<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1720717696063_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1720717696063_N1000B\">Claims are used in tokens to provide information to clients (ID token) and to resources (access token).<\/p><p class=\"par\" id=\"1720717696063_N1000F1721891760246\">The configuration of claims is part of the configuration of the flow or grant that will issue the tokens that contain the claims. This allows for different claims in tokens issued by an authorization code flow or a client credentials grant.<\/p><p class=\"par\" id=\"1720717696063_N1000F1721832598221\">Access tokens will only have claims if they are configured as JWT token and not opaque.<\/p><p class=\"par\" id=\"1720717696063_N1000D\">It is useful to differentiate the following types of claims:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">ID tokens and, to an extent, access tokens may contain a set of claims with a very specific semantic that is defined here: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/openid.net\/specs\/openid-connect-core-1_0.html#IDToken\" target=\"_blank\">OIDC ID token claims<\/a>.<\/li><li class=\"enum-element\">Custom claims have a business semantic and may be freely added to access and ID tokens.  The values of these claims are configurable. A typical set of claims is defined here: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/openid.net\/specs\/openid-connect-core-1_0.html#StandardClaims\" target=\"_blank\">OIDC standard claims<\/a>.<\/li><li class=\"enum-element\">Distributed claims are part of the OIDC specification and can be used to add claims where the content is in a remote location, not in the token itself. <\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1720717696063_N1003A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Default claims<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1720717696063_N1003D\">OAuth 2.0 and OIDC do not specify any claims to be mandatory, but it is very common that the following claims are found in access and ID tokens:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">sub - reference to the subject of the token<\/li><li class=\"enum-element\">aud - describes the intended recipients of the token i.e. the client_id of the client<\/li><li class=\"enum-element\">iss - the issuer of the token<\/li><li class=\"enum-element\">scope - only provided with access tokens. See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1579527945473.html\">OAuth 2.0 scopes<\/a> for details.<\/li><li class=\"enum-element\">acr -  authentication context reference<\/li><\/ul><p class=\"par\" id=\"1720717696063_N10058\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/openid.net\/specs\/openid-connect-core-1_0.html\" target=\"_blank\">OpenID Connect Core 1.0<\/a> defines iss and sub claims as mandatory for ID tokens.<\/p><p class=\"par\" id=\"1720717696063_N10072\">Other, more technical claims about the token\'s validity, PKCE and other purposes exist. Since these claims are added automatically as needed, they are not discussed in detail here.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1720717696063_N1003E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Custom claims<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1720717696063_N10041\">Custom claims can be added to access and ID tokens. Typically custom claims include the following claims:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">context data items<\/li><li class=\"enum-element\">client_id, <\/li><li class=\"enum-element\">OAuth session_id (Airlock IAM proprietary value to identify the OAuth session.<\/li><li class=\"enum-element\">username, user roles<\/li><li class=\"enum-element\">HTTP headers<\/li><li class=\"enum-element\">Scriptable Step results<\/li><\/ul><p class=\"par\" id=\"1720717696063_N10085\">Custom claims are collected at the end of the authentication flow and may be stored in a database. During the issuance of tokens, the values used in custom claims are read from this database. This has the following implications:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Every token will return identical values as they were stored at the start of the session.<\/li><li class=\"enum-element\">Changes in context data items will not be reflected in custom claims until the next time the user authenticates.<\/li><li class=\"enum-element\">The userinfo and resource endpoint do not use the persisted data. Context data items requested through these endpoint will return current values.  <\/li><\/ul><p class=\"par\" id=\"1720717696063_N100B0\"><\/p><div xmlns=\"\" class=\"container-warning info compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1720717696063_N100B5\"><\/p><ul xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Adding values from value providers and value map providers<\/li><li class=\"enum-element\"><span class=\"dialog\">String Value Provider Custom Claim<\/span>  is a plugin that can be used to write individual values into a custom claim. A typical example is:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">HTTP Request Value Provider    <\/li><\/ul><li class=\"enum-element\"><span class=\"dialog\">String From Map Value Provider<\/span> can be used to extract specific keys from a value map and then write the value of this key into a claim. Typical examples are:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">User Identity Map  <\/li><li class=\"enum-element\">Authentication Data Map  <\/li><li class=\"enum-element\">Roles Provider (incl. Tags propagation)  <\/li><li class=\"enum-element\">Script Execution Result Value Map Provider  <\/li><\/ul><\/ul><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1720717696063_N100CB\"><\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1720717696063_N10008\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Distributed claims<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1720717696063_N10046\">Distributed claims can be useful if large amounts of data should be shared with an access or ID token or if data should be shared that stems from a different authority.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1720717696063_N1019B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Claim conditions<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1720717696063_N101A0\">With the <span class=\"dialog\">Custom Claims<\/span> property, custom claims can be added to every token or JSON response after scope policies and scope filtering have been processed. In addition, a <span class=\"dialog\">Claim Condition<\/span> can be set to add custom claims <i class=\"italics\">conditionally<\/i>.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The available claim conditions are:<\/strong> <\/li><li class=\"enum-element\"><i class=\"italics\">Required Scopes Claim Condition<\/i> \u2013 this is met when the configured required scopes have been granted.<\/li><li class=\"enum-element\"><i class=\"italics\">And Claim Condition<\/i>, <i class=\"italics\">Not Claim Condition<\/i>, <i class=\"italics\">Or Claim Condition<\/i> \u2013 these conditions allow logical combinations of conditions. The condition is fulfilled when the logic requirements match the granted scopes\/token\'s claims.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The following plugin types offer the conditional claim property:<\/strong> <\/li><li class=\"enum-element\">Custom ID token claims, i.e. <i class=\"italics\">Custom Claims<\/i> for the <code class=\"codeinline\">OpenIDConnectClaimsConfiguration<\/code> plugin.  <\/li><li class=\"enum-element\">Standard OIDC claims, i.e. <i class=\"italics\">Standard Claims<\/i> for the <code class=\"codeinline\">OpenIDConnectUserInfoEndpointConfig<\/code> plugin.<\/li><li class=\"enum-element\">Custom JWT claims, i.e. <i class=\"italics\">Custom Claims<\/i> for the <code class=\"codeinline\">JwtAccessTokenFormatConfig<\/code> and <code class=\"codeinline\">OpenIDConnectUserInfoEndpointConfig<\/code> plugins.<\/li><li class=\"enum-element\">OAuth 2.0 Resource Providers, i.e. <i class=\"italics\">Resource Providers<\/i> in the <code class=\"codeinline\">OAuth2ResourceConfig<\/code> plugin.    <\/li><li class=\"enum-element\">OAuth 2.0 Token Exchange <i class=\"italics\">Custom Claims<\/i>, i.e. <code class=\"codeinline\">OAuth2TokenExchangeJwtCustomClaimConfig<\/code> plugin.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1720717696063_N100A6\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1721740988070.html\">OAuth 2.0 OIDC Configuration override<\/a> for more information on claim overrides.<\/li><li class=\"enum-element\">See <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849731186.html\">Configuration of IAM as OAuth Authorization Server \/ OpenID Provider<\/a> for information of the configuration of an authorization server.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';