var m_1721740988232Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>User-based IP restrictions<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1721740988232\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">User-based IP restrictions<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1721740988232_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1721740988232_N10009\">The goal of this example is to enforce user-based IP restrictions using a <i class=\"italics\">Scriptable Step<\/i>. The solution has the following properties:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The allowed IP address is stored in CIDR format as a context data item for each user individually.<\/li><li class=\"enum-element\">This context data item can be set per user in the <span class=\"dialog\">Profile<\/span> tab of the Adminapp.<\/li><li class=\"enum-element\">The scriptable step will determine if the actual IP address of the user device  matches the CIDR provided in the context data item.<\/li><li class=\"enum-element\">A failure step is used to terminate the flow if the user\'s IP address does not match the CIDR in the context data item.<\/li><li class=\"enum-element\">The flow will continue normally if no IP restriction is set in the context data item.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1721740988232_N10035\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1721740988232_N10026\">To run the example script on this page, you need to install the additional library <code class=\"codeinline\">cidr.lua<\/code> in the instance directory. <code class=\"codeinline\">cidr.lua<\/code> is a Lua library to handle CIDR formatted IP addresses. It can be downloaded from <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/github.com\/Humbedooh\/lua-cidr\/blob\/main\/cidr.lua\" target=\"_blank\">CIDR library on github<\/a>.<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">To install the <code class=\"codeinline\">cidr.lua<\/code> library in the instance directory, execute the following command:<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1004C\">cp cidr.lua $IAM_instance_dir\/scripting\/lua\/share<\/pre><\/div><\/div><\/div><\/div><\/div><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1721740988232_N10055\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Scriptable step<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1721740988232_N10058\">In this example, the <i class=\"italics\">Scriptable Step<\/i> uses a <i class=\"italics\">Context Data Map<\/i> and a <i class=\"italics\">HTTP Request Information Map<\/i> as input to check if the IP address of the user device matches the pattern provided in the context data.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Proceed as follows:<\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Application and Authentication<\/span> &gt;&gt; <span class=\"dialog\">Default Application<\/span> &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">In property <span class=\"dialog\">Steps<\/span>, create and edit a <span class=\"dialog\">Scriptable Step<\/span> plugin, as follows:<\/li><li class=\"step\">In property <span class=\"dialog\">Input Map<\/span>, create a <span class=\"dialog\">Context Data Map<\/span> plugin and a <span class=\"dialog\">HTTP Request Information Map<\/span> plugin.<\/li><li class=\"step\">In field <span class=\"dialog\">Script<\/span>, add the following Lua code:<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100EC\">-- Example script checks a context data item ipv4_restriction against the current ipv4_address\r\nfunction iam_on_step_init ()\r\n    local cidr = require \'cidr\'\r\n    local ip_and_range = iam.input_map[\"ipv4_restriction\"]\r\n    if (ip_and_range == nil) then\r\n        iam.log:info(\"No user-specific restriction on IP address enforced. IP address is considered in range\")\r\n        return { ip_in_range = \"yes\" }\r\n    end\r\n    iam.log:info(\"Read user-specific IP address restriction: \" .. ip_and_range)\r\n    local network = cidr:network(ip_and_range)\r\n    \r\n    local user_ip = iam.input_map[\"client-ip-v4\"]\r\n    if (user_ip == nil) then\r\n       iam.log:info(\"IAM was not able to determine the IP address of the client. IP address is considered in range\")\r\n       return { ip_in_range = \"yes\" }\r\n    end\r\n    iam.log:info(\"Checking ip address \" .. user_ip)\r\n    local is_in_range = network:match(user_ip)\r\n    if is_in_range then\r\n        iam.log:info(\"User IP address \'\" .. user_ip .. \"\' is in range\")\r\n        return { ip_in_range = \"yes\" }\r\n    end\r\n    iam.log:info(\"User IP address \'\" .. user_ip .. \"\' is NOT in range\")\r\n    return { ip_in_range = \"no\" }\r\nend<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">In property <span class=\"dialog\">Output Map<\/span>, create a new row:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">Set <i class=\"italics\">ip_in_range<\/i> as <span class=\"dialog\">Key<\/span>, and <\/li><li class=\"enum-element\">Add the <span class=\"dialog\">Script Output Declaration<\/span> plugin as <span class=\"dialog\">Plugin<\/span>, and edit it as follows:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In property <span class=\"dialog\">Output Value Type<\/span>, enter \"STRING\".<\/li><li class=\"enum-element\">Enable the <span class=\"dialog\">Required<\/span> property (this is the default setting).<\/li><\/ul><\/ul><li class=\"step result\">You have now configured a scriptable step that checks if the actual IP address of the user matches the allowed IP address set for this user. <\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1721740988232_N100BA\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Failure step<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1721740988232_N100BD\">Next, configure a <i class=\"italics\">Failure Step<\/i>. This step uses the script execution result from the above scriptable step to determine whether to stop the authentication flow. It checks if the value of script output\/key <code class=\"codeinline\">ip_in_range<\/code> matches the regex pattern <i class=\"italics\">^yes$<\/i>. If this is the case, the IP address of the user device matches the CIDR provided in the user\'s context data. Consequently, the failure step is skipped and the authentication flow can continue normally.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Proceed as follows:<\/strong><\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Application and Authentication<\/span> &gt;&gt; <span class=\"dialog\">Default Application<\/span> &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">In property <span class=\"dialog\">Steps<\/span>, create and edit a <span class=\"dialog\">Failure Step<\/span> plugin, as follows:<\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span> and in property <span class=\"dialog\">Error Code<\/span>, enter an error code that specifies the reason for aborting the authentication flow, e.g., <i class=\"italics\">FLOW_ABORTED_INTENTIONALLY<\/i>.  The error code will be included in the response. <\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span> and in property <span class=\"dialog\">Authentication Method Identifier<\/span>, enter the identifier of the authentication method, e.g., PASSWORD. The failed attempts counter of this authentication method will be increased when the flow is terminated.<\/li><li class=\"step\">In section <span class=\"dialog\">Tags\/Guards<\/span> and in property <span class=\"dialog\">Skip Condition<\/span>, create and edit a <span class=\"dialog\">String Regex Condition<\/span> plugin:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In property <span class=\"dialog\">Value Provider<\/span> of the <span class=\"dialog\">String Regex Condition<\/span> plugin, create and edit a <span class=\"dialog\">String From Map Value Provider<\/span> plugin:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In property <span class=\"dialog\">Value Maps<\/span>, add a <span class=\"dialog\">Script Execution Result Value Map Provider<\/span> plugin.<\/li><li class=\"enum-element\">In property <span class=\"dialog\">Key<\/span>, enter <i class=\"italics\">ip_in_range<\/i>.<\/li><\/ul><li class=\"enum-element\">Return to the <span class=\"dialog\">String Regex Condition<\/span> plugin. In property <span class=\"dialog\">Regex Pattern<\/span>, enter <i class=\"italics\">^yes$<\/i>. This is the regex pattern to match with the script output value.<\/li><\/ul><li class=\"step result\">You have now configured a failure step that will be skipped if the script output confirms <code class=\"codeinline\">\"ip_in_range = yes\"<\/code>. In every other case, the failure step will terminate the authentication flow and the PASSWORD failure counter will be increased.<\/li><\/ol><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';