var m_1721740988463Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>JWKS endpoint<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1721740988463\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">JWKS endpoint<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1721740988463_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1721740988463_N10009\">IAM uses digital signatures to prove the authenticity and integrity of issued tokens. A recipient of these tokens must properly verify the tokens\' digital signatures before extending trust to the tokens.<\/p><p class=\"par\" id=\"1721740988463_N1000B\">To validate a signature, the recipient needs a copy of the corresponding public key used by IAM during the signing process. To achieve this, IAM could provide the recipient with a copy of the public key or an IAM URL to query and download a JWKS (JSON Web Key Set) containing all the signing keys IAM currently uses.<\/p><p class=\"par\" id=\"1721740988463_N10010\">IAM already provides a JWKS endpoint as part of the OAuth 2.0\/OIDC authorization server. This endpoint includes all keys on the authorization server and remains unchanged. The JWKS endpoint described here is an IAM-wide REST endpoint that can be used independently from OAuth\/OIDC. The endpoint\'s response contains all IAM keys used for signing. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The  JWKS endpoint response includes public keys from the following plugins:<\/strong><\/li><li class=\"enum-element\"><i class=\"italics\">JWT Ticket RSA Signer Settings<\/i><\/li><li class=\"enum-element\"><i class=\"italics\">JWT Ticket EC Signer Settings<\/i><\/li><li class=\"enum-element\"><i class=\"italics\">Oauth 2.0 and OIDC Private Key JWT Client Authentication<\/i><\/li><li class=\"enum-element\"><i class=\"italics\">OAuth 2.0 and OIDC JWT Access Token Private Key Signature<\/i><\/li><li class=\"enum-element\"><i class=\"italics\">OIDC ID Token Private Key Signature<\/i><\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1721740988463_N1000E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">JWKS endpoint - example<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1721740988463_N10011\">This section provides an example URL of the IAM-wide JWKS REST endpoint exposed by IAM, as well as an example response returned by this JWKS endpoint. The response will contain all the keys that IAM uses for signing purposes. <\/p><p class=\"par\" id=\"1721740988463_N1003B\"><strong class=\"emphasis\">Example URL:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10013\">https:\/\/iam.host.com\/auth-login\/rest\/public\/jwks\/ <\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1721740988463_N10015\"><strong class=\"emphasis\">Example response returned when querying the above URL:<\/strong><\/p><div xmlns=\"\" class=\"container-warning example\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10017\">\"keys\": [\r\n    {\r\n      \"kty\": \"RSA\",\r\n      \"e\":   \"AQAB\",\r\n      \"use\": \"sig\",\r\n      \"kid\": \"383d3a6d0774813c\",\r\n      \"alg\": \"RS512\",\r\n      \"n\":   \"xBMU3...86OMQ\"\r\n    },\r\n    {\r\n      \"kty\": \"RSA\",\r\n      \"e\":   \"AQAB\",\r\n      \"use\": \"sig\",\r\n      \"kid\": \"f4a88e60e5d2c2fa\",\r\n      \"alg\": \"RS256\",\r\n      \"n\":   \"qQCXF...YN84-Q\"\r\n    }\r\n  ]\r\n}<\/pre><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1721740988463_N10019\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration to enable the JWKS endpoint<\/h2><\/div><\/header><div class=\" block-content-ct\"><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">Go to: <br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Advanced Settings<\/span><\/li><li class=\"step\">In property <span class=\"dialog\">JWKS Settings<\/span>, create a <span class=\"dialog\">Loginapp JWKS<\/span> plugin.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1721740988463_N100591722322438415\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Known limitations<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1721740988463_N1005C1722322438415\">Only the Loginapp module provides the JWKS endpoint described here.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1721740988463_N10059\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\">For more information about the OAuth 2.0\/OIDC JWKS endpoint, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1597849731186.html\">Configuration of IAM as OAuth Authorization Server \/ OpenID Provider<\/a>.<\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';