var m_1723740206631Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Escaping HTML values in emails<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1723740206631\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Escaping HTML values in emails<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1723740206631_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1723740206631_N1000B\">In Airlock IAM, several plugins generate email messages and send them to end-users. These emails can contain variables, such as salutation, first name and surname of an end-user. The values of the variables are provided by so-called value providers, such as the <i class=\"italics\">Context Data Map<\/i> value provider for end-user data. <\/p><p class=\"par\" id=\"1723740206631_N10015\">In IAM, emails are sent in plain text by default. Emails in HTML mode present a risk if the variables in HTML are not encoded. However, some situations may require sending emails as HTML. In this case, make sure to escape the HTML values. This article explains how to configure this.<\/p><p class=\"par\" id=\"1723740206631_N1001F\">There are several options to escape HTML values in an email:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Option 1 - Escape all HTML values<\/strong><\/li><li class=\"enum-element\">The property <i class=\"italics\">Escape Values in HTML<\/i> allows escaping all HTML values in an email. This property is enabled by default in IAM. It is available in all plugins that replace variables with values in emails.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The following plugins contain the <i class=\"italics\">Escape Values in HTML<\/i> property:<\/strong><\/li><li class=\"enum-element\"><i class=\"italics\">Email Message Provider<\/i><\/li><li class=\"enum-element\"><i class=\"italics\">Email Identity Verification Step<\/i><\/li><li class=\"enum-element\"><i class=\"italics\">Email Notification Step<\/i><\/li><li class=\"enum-element\"><i class=\"italics\">Flow-based Password Reset<\/i><\/li><li class=\"enum-element\"><i class=\"italics\">Send Email Link Step<\/i><\/li><\/ul><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1723740206631_N100441724850260095\">More recent plugins, such as the <i class=\"italics\">Email Event Subscriber<\/i>, no longer allow unescaped HTML values in emails. They always automatically escape HTML values when <i class=\"italics\">Send As HTML<\/i> is activated.<\/p><\/div><\/div><\/div><\/div><\/div><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Option 2 - Selectively escape specific HTML values<\/strong><\/li><li class=\"enum-element\">IAM also supports the escaping of specific HTML variables selectively, with the <i class=\"italics\">Transforming Value Map Provider<\/i> feature. This feature allows configuring a list of value providers together with an <i class=\"italics\">HTML String Escaper<\/i> plugin. All values provided by the value providers in the list will be HTML-escaped; all values provided by other value providers appear unescaped in HTML code in the mail. Thus, the feature guarantees backwards compatibility for customers who use legitimate HTML in their user data that should not be escaped, such as names, e.g., <i class=\"italics\">Phileas O&amp;apos;Connor<\/i>.   <\/li><div xmlns=\"\" class=\"container-warning observe compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_observe\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1723740206631_N1005A\">For security reasons, only use unescaped HTML values in emails for low-security applications and if it is considered safe!<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1723740206631_N10068\">The section below explains how to configure the <i class=\"italics\">Transforming Value Map Provider<\/i> feature.<\/p><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1723740206631_N1001C\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Escaping HTML values with the Transforming Value Map Provider<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1723740206631_N10067\">To escape specific HTML values in an email using the <i class=\"italics\">Transforming Value Map Provider<\/i> feature, proceed as follows:<\/p><ol class=\"enum-enum-instruction container-enum instruction fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"step\">In the <span class=\"dialog\">Loginapp<\/span>, go to the dialog of the relevant email-generating plugin. In this dialog, go to the property where you specifiy the value providers for variables in emails. For example, in the <span class=\"dialog\">Email Message Provider<\/span> plugin, this is the property <span class=\"dialog\">Value Providers<\/span>. <\/li><li class=\"step\">In this property, first create and edit the value provider maps that provide values for variables that must <strong class=\"emphasis\">not <\/strong> be HTML-escaped. <\/li><li class=\"step\">Then, at the end of the list, create the <span class=\"dialog\">Transforming Value Map Provider<\/span> plugin for the HTML-escaped variables. Edit the plugin as follows:<\/li><li class=\"step\">In property <span class=\"dialog\">Value Providers<\/span>, specify the maps providing the values that must be HTML-escaped. If required, you can add more than one provider map.<\/li><li class=\"step\">In property <span class=\"dialog\">Transformations<\/span>, create the <span class=\"dialog\">HTML String Escaper<\/span> plugin. <\/li><li class=\"step\">Return to the mail-generating plugin. Disable the property <span class=\"dialog\">Escape Values in HTML<\/span>, if available (it may be in the section <span class=\"dialog\">Advanced Settings<\/span>). <\/li><li class=\"step\">Activate your configuration.<\/li><li class=\"step result\">The emails sent by IAM in HTML mode will now HTML-escape the values specified above. <\/li><\/ol><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';