var m_1725073464459Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Correlation ID for better traceability<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1725073464459\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Correlation ID for better traceability<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1725073464459_N1000A\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1725073464459_N1000B\">The Correlation ID links incoming HTTP requests with outgoing requests and log files by using a consistent reference ID. This ensures that all actions stemming from a specific user request are grouped together, enhancing the traceability of the use case through IAM and third-party systems. Example use cases include transaction approval procedures or authentication processes using the Airlock 2FA app as a second factor.<\/p><p class=\"par\" id=\"1725073464459_N1001A\"><strong class=\"emphasis\">How does the correlation ID work?<\/strong><\/p><p class=\"par\" id=\"1725073464459_N1001D\">At the beginning of a specific transaction, an upstream third party system of Airlock IAM generates an ID and sends this ID in the HTTP request header to IAM. IAM logs this ID as <code class=\"codeinline\">corr_id<\/code> in its log files. Additionally, IAM forwards the ID unchanged to the downstream third party system(s) that follow in the transaction process. <\/p><p class=\"par\" id=\"1725073464459_N1002D\">The following graphic illustrates the functioning of the Correlation ID feature. Within IAM, the feature is supported by all modules (Loginapp, Adminapp, Transaction Approval, etc.) as well as all plugins that define HTTP calls to third party systems.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1725073464459_N10027\"><img alt=\"IAM_correlation-ID\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/05_Media\/Vector_drawings\/IAM\/35118.IAM_correlation-ID.theme\/1.2\/en-us.35118.IAM_correlation-ID_original.svg\" style=\"width:;height:443px;border:0;\"\/><\/div><\/figure><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1725073464459_N10025\">The responsibility for generating  the correlation ID lies with the third party system that precedes IAM in the transaction flow. This upstream system determines which correlation ID to set where and when in the incoming request to IAM. IAM only receives, logs and forwards the correlation ID (if configured). <\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1725073464459_N100341726143932262\">If the incoming HTTP request does not contain a correlation ID, IAM will not generate one itself. In this case, no correlation ID will be available for this specific transaction.<\/p><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1725073464459_N10041\">To preserve backward compatibility, the <code class=\"codeinline\">corr_id<\/code> is only set in the <i class=\"italics\">structured log<\/i> by default (status Q3 2024). It is possible to also log the correlation ID in the <i class=\"italics\">Main log<\/i>, but this requires a manual configuration - for instructions, see further below. <\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1725073464459_N10047\">The correlation ID is currently not supported for the parsable log files (used by the Adminapp log viewer).<\/p><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1725073464459_N10043\">Within IAM, the <code class=\"codeinline\">X-Correlation-ID<\/code> header field is set as the default HTTP header field to transfer the correlation ID. However, the <code class=\"codeinline\">X-Correlation-ID<\/code> header is no general standard. It is possible to use another header for the incoming and\/or outgoing correlation ID, if you or your third party systems would prefer this.<\/p><p class=\"par\" id=\"1725073464459_N1004C\">Also, the HTTP header field containing the <i class=\"italics\">incoming <\/i>correlation ID does not have to be the same as the HTTP header field containing the <i class=\"italics\">outgoing <\/i> correlation ID. This allows for greater flexibility in adjusting your settings to those of your third party systems. <\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1725073464459_N10094\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuring the Correlation ID feature<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1725073464459_N10099\">To enable the Correlation ID feature, you need to specify which header fields to use for transferring the value of the correlation ID in the incoming and outgoing HTTP requests.<\/p><p class=\"par\" id=\"1725073464459_N10052\"><strong class=\"emphasis\">Prerequisites<\/strong><\/p><p class=\"par\" id=\"1725073464459_N100561725552410441\">As a prerequisite for configuring the Correlation ID feature, first check with your third party systems which HTTP header(s) to use.<\/p><p class=\"par\" id=\"1725073464459_N100A9\"><strong class=\"emphasis\">Configuring the <i class=\"italics\">incoming<\/i> correlation ID<\/strong><\/p><p class=\"par\" id=\"1725073464459_N1007E\"><i class=\"italics\">Correlation ID Settings<\/i> plugin. This plugin can be specified on the root page of all IAM modules (Loginapp, Adminapp, Transaction Approval, etc.) and on the <span class=\"dialog\">Main Settings<\/span> root page. If the header field for the incoming correlation ID differs per IAM module, set the plugin for each module individually. If not, use the <span class=\"dialog\">Main Settings<\/span> root page for global settings. <\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">To configure the incoming correlation ID, proceed as follows:<\/li><li class=\"step\">Go to the root page of <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">the <span class=\"dialog\">Main Settings<\/span> module, to specify the incoming correlation ID settings globally. <\/li><li class=\"enum-element\">a specific module, such as <span class=\"dialog\">Loginapp<\/span> or <span class=\"dialog\">Transaction Approval<\/span>, if you want to specify the incoming correlation ID settings for this module explicitly. <\/li><\/ul><li class=\"step\">In the property <span class=\"dialog\">Correlation ID Settings<\/span>, create and edit the <span class=\"dialog\">Correlation ID Settings<\/span> plugin, as follows below. (If the root page has more than one section, you will find the <span class=\"dialog\">Correlation ID Settings<\/span> property in the <span class=\"dialog\">Advanced Settings<\/span> section.)<\/li><li class=\"step\">In the property <span class=\"dialog\">Header Name<\/span>, define the HTTP header from which to extract the correlation ID on incoming requests.<\/li><li class=\"step\">In the property <span class=\"dialog\">Validation Pattern<\/span>, define the regular expression against which the incoming correlation ID will be matched. If the correlation ID value matches the regular expression, IAM logs it for the entire transaction scope triggered by the current HTTP request. If the ID value does not match, no correlation ID will be logged. By setting this property, you can prevent unexpected and\/or undesired values from being written to the log files.<\/li><li class=\"step result\">You have now configured the settings for the incoming correlation ID. Proceed with the following section to configure the settings for the outgoing correlation ID.<\/li><\/ol><p class=\"par\" id=\"1725073464459_N10091\"><strong class=\"emphasis\">Configuring the <i class=\"italics\">outgoing<\/i> correlation ID<\/strong><\/p><p class=\"par\" id=\"1725073464459_N10054\">You set the HTTP request header field to transfer the outgoing correlation ID value in the <i class=\"italics\">Correlation ID Header Name<\/i> property. This property is available in most plugins that define HTTP calls to third party systems.    <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">This includes the following plugins:<\/strong><\/li><li class=\"enum-element\">All HTTP-based SMS gateway plugins<\/li><li class=\"enum-element\"><i class=\"italics\">HTTP Client Config<\/i> plugin, if used by<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">OAuth\/OIDC clients<\/li><li class=\"enum-element\">On-behalf login identity propagators<\/li><\/ul><li class=\"enum-element\"><i class=\"italics\">HTTP Password Service<\/i> plugin<\/li><li class=\"enum-element\"><i class=\"italics\">Access Cookie Identity Propagator<\/i> plugin<\/li><li class=\"enum-element\"><i class=\"italics\">SAML Access Cookie Identity Propagator<\/i> plugin<\/li><\/ul><div xmlns=\"\" class=\"container-warning important\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_important\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1725073464459_N10096\">Currently (Q3 2024), the <i class=\"italics\">Event Subscriber<\/i> plugins do <i class=\"italics\">not <\/i> support the correlation ID. <\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1725073464459_N100FB\">The same is true for the <i class=\"italics\">Futurae cloud service<\/i>. As a result, when an end-user authenticates with the Airlock 2FA app, the corresponding requests sent to the Futurae cloud service do not include a correlation ID.<\/p><\/div><\/div><\/div><\/div><\/div><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">To configure the outgoing correlation ID, proceed as follows:<\/li><li class=\"step\">The outgoing correlation ID settings can be configured in all plugins that define HTTP calls to third party systems (see the list above). <br\/>Go to the dialog of the plugin for which you want to configure the outgoing correlation ID.<\/li><li class=\"step\">In the property  <span class=\"dialog\">Correlation ID Header Name<\/span>, enter the HTTP header field to be used to forward the correlation ID. If the current plugin sends an outgoing HTTP request to a third party system, it will fill this request header field with the relevant correlation ID value.<\/li><div xmlns=\"\" class=\"container-warning info compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1725073464459_N10117\">If the plugin dialog has more than one section, you will find the <span class=\"dialog\">Correlation ID Header Name<\/span> property in the <span class=\"dialog\">Advanced Settings<\/span> section.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"step\">Repeat the above steps for all plugins for which you want to configure the outgoing correlation ID.<\/li><li class=\"step\">Activate your configuration.<\/li><li class=\"step result\">You have now configured the Correlation ID feature.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1725073464459_N10125\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Logging the correlation ID in the Main log<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1725073464459_N10128\">IAM logs the value of the incoming correlation ID in its logfiles as <code class=\"codeinline\">corr_id<\/code>. To preserve backward compatibility, the <code class=\"codeinline\">corr_id<\/code> is only set in the <i class=\"italics\">structured log<\/i> by default (status Q3 2024). It is possible to also log the correlation ID in the <i class=\"italics\">Main<\/i> log, but this requires a manual configuration. This section explains how to proceed.<\/p><p class=\"par\" id=\"1725073464459_N10147\">The Main log file can be configured manually in the <code class=\"codeinline\">instance.properties<\/code> file of your IAM instance. This file is located in the instance directory (e.g., <code class=\"codeinline\">&lt;configuration-dir&gt;\/instances\/auth\/instance.properties<\/code>).<\/p><p class=\"par\" id=\"1725073464459_N1014F\">To log the correlation ID in the Main log, you must add the following value to the <code class=\"codeinline\">iam.log.main.pattern<\/code> property in the <code class=\"codeinline\">instance.properties<\/code> file (under <code class=\"codeinline\">### LOGGING<\/code>):<\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1015A\">%e{mdc\\:CORRELATION_ID}<\/pre><\/div><\/div><\/div><\/div><\/div><p class=\"par\" id=\"1725073464459_N1015C\">The following code snippet shows a full example of the <code class=\"codeinline\">iam.log.main.pattern<\/code> property including the <code class=\"codeinline\">%e{mdc\\:CORRELATION_ID}<\/code> value: <\/p><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N1016A\">iam.log.main.pattern = %d{DEFAULT} %-5p [IAM - ${sys\\:iam.instance.name} -  ${applicationName} - SID\\: %18e{mdc\\:GSID\\:0} - RID\\: %18e{mdc\\:REQUEST_ID\\:0} - CORR_ID\\: %e{mdc\\:CORRELATION_ID}] | %e{header\\:3}%c{1}\\: %m%n <\/pre><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">For more information on<\/strong><\/li><li class=\"enum-element\">The <code class=\"codeinline\">instance.properties<\/code> file, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1649929286196.html\">Airlock IAM instance configuration<\/a><\/li><li class=\"enum-element\">The Main log, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1594920816701.html\">Main log format<\/a>.<\/li><li class=\"enum-element\">The format of the structured log and its attributes, see  <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1594920816703.html\">Structured log format<\/a>.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1725073464459_N1016B\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1594920816703.html\">Structured log format<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1594920816701.html\">Main log format<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1649929286196.html\">Airlock IAM instance configuration<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';