var m_1725073466309Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Enforced password change<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1725073466309\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Enforced password change<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1725073466309_N10009\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1725073466309_N1000A\">This example shows how to enforce a password change in the case of a weak password, by using the Scriptable Step. Upon each end-user login, the script checks via the  <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/haveibeenpwned.com\/\" target=\"_blank\">haveibeenpwned<\/a> website whether the password has been breached. If yes, the end-user is forced to change their password. <\/p><p class=\"par\" id=\"1725073466309_N10023\">A <i class=\"italics\">breached<\/i> password is a password that has been previously exposed in data breaches. This exposure poses a substantial risk to the end-user\'s account(s), as the now-known password may be misused in cyber attacks such as credential stuffing or password spraying. <i class=\"italics\">Credential stuffing<\/i> occurs when a malicious person tries out great numbers of breached username\/password pairs to fraudulently gain access to a specific user account. <i class=\"italics\">Password spraying<\/i> is a tactic where a hacker attempts to break into multiple target accounts by using the same single breached password.<\/p><p class=\"par\" id=\"1725073466309_N1002F\">The script described here prevents the above attacks by forcing the end-user to change their password in the case of a breach. No compromised passwords will be used to access your application, making your system more secure.  <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">This is how the script works:<\/strong><\/li><li class=\"enum-element\">Upon end-user login, the script takes the end-user\'s password and hashes it with SHA1. Thus, the real password is not revealed during the password check.<\/li><li class=\"enum-element\">Next, the script sends the first 5 characters of the password hash, i.e., the hash prefix, to the website <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/haveibeenpwned.com\/\" target=\"_blank\">haveibeenpwned<\/a>. This website returns the hash suffixes of all known passwords that have the same hash prefix as the end-user\'s password. The script then checks whether the full hash of the end-user\'s password matches the full hash of one or more of the returned passwords. If yes, the end-user password has been breached.<\/li><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1725073466309_N1001A\">For more details on how the breach check works, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/haveibeenpwned.com\/API\/v3#SearchingPwnedPasswordsByRange\" target=\"_blank\">haveibeenpwned API<\/a>.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"enum-element\">If a password breach occurred, an acknowledge message step informs the end-user about the number of breaches, and prompts the end-user to change their password. At the same time, a red flag (step) is raised, which in turn triggers the mandatory password change step. <\/li><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1725073466309_N10042\">For more information on red flags, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1594636415664.html#1594636415664_N10023\">Red flags<\/a>.<\/p><\/div><\/div><\/div><\/div><\/div><li class=\"enum-element\">If the end-user\'s password has not been breached, the end-user can log in normally.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1725073466309_N10011\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Authentication flow<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1725073466309_N10063\">The following graphic shows the authentication flow used in this example.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1725073466309_N10073\"><img alt=\"Scriptable-Step_Enforce-Password-Flow\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/05_Media\/Vector_drawings\/IAM\/Flow_drawings\/35115.Scriptable-Step_Enforce-Password-Flow.theme\/1.0\/en-us.35115.Scriptable-Step_Enforce-Password-Flow_original.svg\" style=\"width:;height:146px;border:0;\"\/><\/div><\/figure><ol class=\"enum-enum-instruction container-enum instruction Numeric\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">The authentication flow consists of the following steps:<\/strong><\/li><li class=\"step\">The flow starts with the default <i class=\"italics\">Username Password Authentication Step<\/i>, where the end-user authenticates with username and password to the application in question.<\/li><li class=\"step\">The script in the <i class=\"italics\">Scriptable Step<\/i> takes the end-user password from the previous step and checks whether the password is insecure and has been breached. The script\'s output contains two keys: The <code class=\"codeinline\">password_safe<\/code> Boolean key indicates the secureness of the end-user password. If there has been a breach, the <code class=\"codeinline\">password_breached_count<\/code> key counts the number of times the password has been breached.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">If the value of the <code class=\"codeinline\">password_safe<\/code> key matches the regex pattern <i class=\"italics\"><code class=\"codeinline\">^false$<\/code><\/i>, <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The <i class=\"italics\">Acknowledge Message Step<\/i> informs the end-user about the number of breaches based on the value of the <code class=\"codeinline\">password_breached_count<\/code> key, and prompts the user to change their password. <\/li><li class=\"enum-element\">Additionally, the <i class=\"italics\">Red Flag Raising Step<\/i> raises a so-called red flag, which triggers the mandatory password change step.<\/li><li class=\"enum-element\">The <i class=\"italics\">Mandatory Password Change Step<\/i> forces the end-user to change their password.<\/li><\/ul><li class=\"enum-element\">If the value of the <code class=\"codeinline\">password_safe<\/code> key matches the regex pattern <i class=\"italics\"><code class=\"codeinline\">^true$<\/code><\/i>, all three previous steps are skipped.<\/li><\/ul><li class=\"step\">The authentication flow ends when the end-user either authenticated successfully right away with a secure password (<code class=\"codeinline\">password_safe<\/code>  = <i class=\"italics\">true<\/i>), or when the user successfully changed their password. In both cases, the end-user can access the desired application.<\/li><div xmlns=\"\" class=\"container-warning notice compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1725073466309_N10013\">Note that the newly set password is <i class=\"italics\">not<\/i> checked by the script.<\/p><\/div><\/div><\/div><\/div><\/div><\/ol><p class=\"par\" id=\"1725073466309_N100D1\">See further below how to configure the above mentioned steps (except the <i class=\"italics\">Username Password Authentication Step<\/i>).<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1725073466309_N1001E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1725073466309_N100AD\">To run the script used in this example, you need to install the following Lua libraries in the IAM instance directory:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><i class=\"italics\">Lua-cURL<\/i>: This Lua shared library sends and receives REST requests from a Lua script.<\/li><li class=\"enum-element\"><i class=\"italics\">Lua sha1<\/i>: This Lua module computes SHA-1 and HMAC-SHA1 signature computations in Lua.<\/li><\/ul><p class=\"par\" id=\"1725073466309_N100BB\">Both libraries can be installed with the Luarocks package manager, which you can download from here: <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/luarocks.org\/\" target=\"_blank\">https:\/\/luarocks.org\/<\/a>. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">To install the <i class=\"italics\">Lua-cURL<\/i> and the <i class=\"italics\">Lua sha1<\/i> libraries in the instance directory, execute the following commands:<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N10110\">luarocks install --tree $IAM_instance_dir\/scripting\/lua lua-cURL<\/pre><\/div><\/div><\/div><\/div><\/div><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N101191726060008368\">luarocks install --tree $IAM_instance_dir\/scripting\/lua sha1<\/pre><\/div><\/div><\/div><\/div><\/div><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1725073466309_N10014\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuring the Scriptable Step<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1725073466309_N10093\">This section explains how to configure the Scriptable Step used in our example. This step checks if the password entered by the end-user upon login is secure or if it has been breached, based on a script.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Proceed as follows:<\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Application and Authentication<\/span> &gt;&gt; <span class=\"dialog\"><i class=\"italics\">&lt;application in question&gt;<\/i><\/span> &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span>, in property <span class=\"dialog\">Steps<\/span>, create and edit a <span class=\"dialog\">Scriptable Step<\/span> plugin, as follows:<\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span>, in property <span class=\"dialog\">Input Map<\/span>, create a <span class=\"dialog\">User Passwords Map<\/span> plugin.<\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span>, in field <span class=\"dialog\">Script<\/span>, add the following Lua script:<\/li><div xmlns=\"\" class=\"container-buttons-notice\"><a class=\"actionButton actionButtonShow\" href=\"#\"><span class=\"showMore\">Show more<\/span><span class=\"showLess\">Show less<\/span><\/a><a class=\"actionButton actionButtonCopy\" href=\"#\">copy<\/a><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div character-limit=\"200\" class=\"content-notice\"><div class=\"warning-notice_commands\"><div class=\"warning-notice\"><pre xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"code\" id=\"N100EC\">local curl = require(\'cURL\') \r\nlocal sha1 = require(\"sha1\") \r\n \r\nfunction iam_on_step_init () \r\n    iam.output_map = {} \r\n    local fullHash = string.upper(sha1.sha1(iam.input_map[\"PASSWORD\"])) \r\n    local hashPrefix = string.sub(fullHash, 1, 5) \r\n \r\n    -- https:\/\/haveibeenpwned.com\/API\/v3#SearchingPwnedPasswordsByRange \r\n    local response, responseCode = performPwndCheck(hashPrefix) \r\n \r\n    if response == \"\" and responseCode == 200 then \r\n        return { password_safe = true, password_breached_count = 0 } \r\n    else \r\n        suffixes = parseResponse(response) \r\n        for i = 1, #suffixes do \r\n            local currentSuffix = string.sub(suffixes[i], 1, 35) \r\n            if currentHashEqualsInitialHash(hashPrefix .. currentSuffix, fullHash) then \r\n                local currentBreachCount = tonumber(string.sub(suffixes[i], 37)) \r\n                return { password_safe = false, password_breached_count = currentBreachCount } \r\n            end \r\n        end \r\n        return { password_safe = true, password_breached_count = 0 } \r\n    end \r\nend \r\n \r\nfunction performPwndCheck(prefix) \r\n    local c = curl.easy { url = \'https:\/\/api.pwnedpasswords.com\/range\/\' .. prefix } \r\n    local body = {} \r\n    c:setopt_writefunction(table.insert, body) \r\n    c:perform() \r\n    return table.concat(body), c:getinfo_response_code() \r\nend \r\n \r\nfunction parseResponse(response) \r\n    hashes = {} \r\n    for line in response:gmatch(\"[^\\n]+\") do \r\n        table.insert(hashes, line) \r\n    end \r\n    return hashes \r\nend \r\n \r\nfunction currentHashEqualsInitialHash(currentHash, initialHash) \r\n    return string.upper(currentHash) == initialHash \r\nend<\/pre><\/div><\/div><\/div><\/div><\/div><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span>, in property <span class=\"dialog\">Output Map<\/span>, configure two <span class=\"dialog\">Script Output Declaration<\/span> plugins, as follows:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">First <span class=\"dialog\">Script Output Declaration<\/span> plugin:<\/strong><\/li><li class=\"enum-element\">In property <span class=\"dialog\">Output Value Type<\/span>, enter <i class=\"italics\">NUMBER<\/i>.<\/li><li class=\"enum-element\">Enable the <span class=\"dialog\">Required<\/span> property (this is the default setting).<\/li><li class=\"enum-element\">Return to the <span class=\"dialog\">Scriptable Step<\/span> dialog. In property <span class=\"dialog\">Output Map<\/span>, field <span class=\"dialog\">Key<\/span>, enter <i class=\"italics\">password_breached_count<\/i> as key for this first <span class=\"dialog\">Script Output Declaration<\/span> plugin.<\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Second <span class=\"dialog\">Script Output Declaration<\/span> plugin:<\/strong><\/li><li class=\"enum-element\">In property <span class=\"dialog\">Output Value Type<\/span>, enter <i class=\"italics\">BOOLEAN<\/i>.<\/li><li class=\"enum-element\">Enable the <span class=\"dialog\">Required<\/span> property (this is the default setting).<\/li><li class=\"enum-element\">Return to the <span class=\"dialog\">Scriptable Step<\/span> dialog. In property <span class=\"dialog\">Output Map<\/span>, field <span class=\"dialog\">Key<\/span>, enter <i class=\"italics\">password_safe<\/i> as key for this second <span class=\"dialog\">Script Output Declaration<\/span> plugin.<\/li><\/ul><li class=\"step result\">You have now configured a scriptable step that checks if the password entered by the end-user upon login is secure or if it has been breached.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1725073466309_N101BF\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuring the Acknowledge Message Step<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1725073466309_N101C4\">This section explains how to configure the Acknowledge Message Step used in our example. If the execution of the script indicates that the end-user\'s password is insecure, this step informs the end-user about the number of breaches, and prompts the end-user to change their password.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Proceed as follows:<\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Application and Authentication<\/span> &gt;&gt; <span class=\"dialog\"><i class=\"italics\">&lt;application in question&gt;<\/i><\/span> &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span>, in property <span class=\"dialog\">Steps<\/span>, create and edit an <span class=\"dialog\">Acknowledge Message Step<\/span> plugin, as follows:<\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span>, property <span class=\"dialog\">Server Message<\/span>, create and edit a <span class=\"dialog\">Template-based String Provider<\/span> plugin, as follows:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In the property <span class=\"dialog\">Value Map Providers<\/span>, create the <span class=\"dialog\">Script Execution Result Value Map Provider<\/span> plugin. This plugin will provide the value for the <code class=\"codeinline\">password_breached_count<\/code> variable used in the <span class=\"dialog\">Template<\/span> field below. The plugin takes the value from the <code class=\"codeinline\">password_breached_count<\/code> key in the script execution result.<\/li><li class=\"enum-element\">In field <span class=\"dialog\">Template<\/span>, enter the text that will be shown to the end-user if their password is breached and thus insecure, and must be changed. In this example, the following text is used: <\/li><div xmlns=\"\" class=\"container-warning example compact\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/warning_ico_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_example\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1725073466309_N10209\">Your password is not secure. It has been breached ${password_breached_count} times. You have to change it.<\/p><\/div><\/div><\/div><\/div><\/div><\/ul><li class=\"step\">Return to the <span class=\"dialog\">Acknowledge Message Step<\/span> plugin dialog. In section <span class=\"dialog\">Tags\/Guards<\/span>, the property <span class=\"dialog\">Skip Condition<\/span> defines the condition that must be fulfilled to skip this step. This is the case when the end-user\'s password is secure, and the script outcome key <code class=\"codeinline\">password_safe<\/code> has value <i class=\"italics\">true<\/i>. To configure the corresponding condition, create and edit a <span class=\"dialog\">String Regex Condition<\/span> plugin, as follows: <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The property <span class=\"dialog\">Value Provider<\/span> defines the value provider delivering the value for the condition check. Here, create and edit a <span class=\"dialog\">String From Map Value Provider<\/span>, as follows: <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In property <span class=\"dialog\">Value Maps<\/span>, create the <span class=\"dialog\">Script Execution Result Value Map Provider<\/span> plugin. This plugin provides the result of the script execution. <\/li><li class=\"enum-element\">In property <span class=\"dialog\">Key<\/span>, enter <i class=\"italics\">password_safe<\/i>. The value of this key after script execution is used as input for the condition check.<\/li><\/ul><li class=\"enum-element\">Return to the <span class=\"dialog\">String Regex Condition<\/span> plugin dialog. In property <span class=\"dialog\">Regex Pattern<\/span>, enter <i class=\"italics\">^true$<\/i>. If the value of the <code class=\"codeinline\">password_safe<\/code> key matches this pattern, the condition to skip this <span class=\"dialog\">Acknowledge Message Step<\/span> is fulfilled.<\/li><\/ul><li class=\"step\">Return to the <span class=\"dialog\">Acknowledge Message Step<\/span> plugin dialog. In section <span class=\"dialog\">Tags\/Guards<\/span>, the property <span class=\"dialog\">Pre Condition<\/span> defines the condition that must be fulfilled to execute this step. This is the case when the end-user\'s password is insecure, and the script outcome key <code class=\"codeinline\">password_safe<\/code> has value <i class=\"italics\">false<\/i>. To configure the corresponding condition, create and edit a <span class=\"dialog\">String Regex Condition<\/span> plugin as described in the previous step, with one exception:  <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In the <span class=\"dialog\">String Regex Condition<\/span> plugin dialog, in property <span class=\"dialog\">Regex Pattern<\/span>, enter <strong class=\"emphasis\"><i class=\"italics\">^false$<\/i><\/strong> (instead of <i class=\"italics\">^true$<\/i>). If the value of the <code class=\"codeinline\">password_safe<\/code> key matches this pattern, the condition to execute this <span class=\"dialog\">Acknowledge Message Step<\/span> is fulfilled.<\/li><\/ul><li class=\"step result\">You have now configured an acknowledge message step. If the execution of the script indicates that the end-user\'s password is insecure, this step informs the end-user about the number of breaches, and prompts the end-user to change their password.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1725073466309_N10274\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuring the Red Flag Raising Step<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1725073466309_N10279\">This section explains how to configure the Red Flag Raising Step used in our example. If the execution of the script indicates that the end-user\'s password is insecure, this red flag raising step raises a red flag, which triggers the mandatory password change step.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Proceed as follows:<\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Application and Authentication<\/span> &gt;&gt; <span class=\"dialog\"><i class=\"italics\">&lt;application in question&gt;<\/i><\/span> &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span>, in property <span class=\"dialog\">Steps<\/span>, create and edit a <span class=\"dialog\">Red Flag Raising Step<\/span> plugin, as follows:<\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span>, the property <span class=\"dialog\">Condition<\/span> defines the condition that must be fulfilled to raise the red flag. This is the case when the end-user\'s password is insecure, and the script outcome key <code class=\"codeinline\">password_safe<\/code> has value <i class=\"italics\">false<\/i>. To configure the corresponding condition, create and edit a <span class=\"dialog\">String Regex Condition<\/span> plugin, as follows:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The property <span class=\"dialog\">Value Provider<\/span> defines the value provider delivering the value for the condition check. Here, create and edit a <span class=\"dialog\">String From Map Value Provider<\/span>, as follows: <\/li><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">In property <span class=\"dialog\">Value Maps<\/span>, create the <span class=\"dialog\">Script Execution Result Value Map Provider<\/span> plugin. This plugin provides the result of the script execution. <\/li><li class=\"enum-element\">In property <span class=\"dialog\">Key<\/span>, enter <i class=\"italics\">password_safe<\/i>. The value of this key after script execution is used as input for the condition check.<\/li><\/ul><li class=\"enum-element\">Return to the <span class=\"dialog\">String Regex Condition<\/span> plugin dialog. In property <span class=\"dialog\">Regex Pattern<\/span>, enter <i class=\"italics\">^false$<\/i>. If the value of the <code class=\"codeinline\">password_safe<\/code> key matches this pattern, the condition to raise the red flag is fulfilled.<\/li><\/ul><li class=\"step\">Return to the <span class=\"dialog\">Red Flag Raising Step<\/span> plugin dialog. The property <span class=\"dialog\">Red Flag<\/span> defines the red flag that must be raised if the above condition is fulfilled. Create a <span class=\"dialog\">Mandatory Password Change Red Flag<\/span> plugin and give it an appropriate name in property <span class=\"dialog\">Name<\/span>. Remember the plugin\'s name and\/or its identifier - you need it again when configuring the next step, the Mandatory Password Change Step.<\/li><li class=\"step result\">You have now configured a red flag raising step. If the execution of the script indicates that the end-user\'s password is insecure, this step raises a red flag, which triggers the mandatory password change step.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1725073466309_N10315\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuring the Mandatory Password Change Step<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1725073466309_N1031A\">This section explains how to configure the Mandatory Password Change Step used in our example. If the execution of the script indicates that the end-user\'s password is insecure, this step forces the end-user to change their password.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Proceed as follows:<\/li><li class=\"step\">Go to:<br\/><span class=\"dialog\">Loginapp<\/span> &gt;&gt; <span class=\"dialog\">Application and Authentication<\/span> &gt;&gt; <span class=\"dialog\"><i class=\"italics\">&lt;application in question&gt;<\/i><\/span> &gt;&gt; <span class=\"dialog\">Authentication Flow<\/span><\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span>, in property <span class=\"dialog\">Steps<\/span>, create and edit a <span class=\"dialog\">Mandatory Password Change Step<\/span> plugin, as follows:<\/li><li class=\"step\">The sections <span class=\"dialog\">Basic Settings<\/span> and <span class=\"dialog\">Advanced Settings<\/span> define the settings of an authentication by password. You can leave the default settings unchanged. <\/li><li class=\"step\">In section <span class=\"dialog\">Tags\/Guards<\/span>, in property <span class=\"dialog\">Red Flag<\/span>, select the  <span class=\"dialog\">Mandatory Password Change Red Flag<\/span> that you created for the Red Flag Raising Step plugin. This red flag will be deactivated (\"lowered\") when the mandatory password change step is executed.<\/li><li class=\"step result\">You have now configured the mandatory password change step.<\/li><li class=\"step\">Activate your configuration.<\/li><li class=\"step result\">You have now configured an authentication flow that enforces a password change in the case of a weak password, by using the Scriptable Step. <\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1725073466309_N1008E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Internal links:<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-detail\" href=\"..\/data\/1594636415664.html#1594636415664_N10023\">Red flags<\/a><\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">External links<\/strong><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/haveibeenpwned.com\/\" target=\"_blank\">haveibeenpwned<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/haveibeenpwned.com\/API\/v3#SearchingPwnedPasswordsByRange\" target=\"_blank\">haveibeenpwned API<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-url\" href=\"https:\/\/luarocks.org\/\" target=\"_blank\">https:\/\/luarocks.org\/<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';