var m_1726159367528Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Airlock 2FA Trusted Session Binding<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1726159367528\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Airlock 2FA Trusted Session Binding<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1726159367528_N1000A\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">\u200B\u200B\u200B\u200B\u200B<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1726159367528_N1000D\">The Airlock 2FA <i class=\"italics\">Trusted Session Binding<\/i> feature is a security feature that makes <i class=\"italics\">token enrollment<\/i> and <i class=\"italics\">app recovery<\/i> more secure by binding these actions to an IAM authentication flow or a protected self-service flow.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1726159367528_N10015\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Prerequisites<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">To use the <i class=\"italics\">Trusted Session Binding<\/i> the following requirements must be met:<\/li><li class=\"enum-element\">The feature is for custom mobile apps (e.g. e-banking apps) using the Futurae SDK only.<\/li><li class=\"enum-element\">The standard Airlock 2FA app does not support the feature.<\/li><li class=\"enum-element\">Existing custom apps must be adapted to use the feature.<\/li><li class=\"enum-element\">The feature requires a special Airlock 2FA license bundle. Please contact <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-mailto\" href=\"mailto:\"><\/a><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-mailto\" href=\"mailto:order@airlock.com?subject=Licensing\">order@airlock.com<\/a> for further details.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1726159367528_N10043\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Motivation<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">There are critical Airlock 2FA-related workflows in which Airlock IAM is not directly involved. These include<\/li><li class=\"enum-element\">token enrollment via letter (scan QR code from a printed letter)<\/li><li class=\"enum-element\">app recovery (from cloud backup)<\/li><\/ul><p class=\"par\" id=\"1726159367528_N1004D\">Depending on the security requirements and threat model, this may be fine. Where this is not enough, the <i class=\"italics\">Trusted Session Binding<\/i> feature helps further increase security: It allows binding the action (enrollment or recovery) to an IAM flow and may thus guarantee that the action can only be taken by a legitimate end-user.<\/p><p class=\"par\" id=\"1726159367528_N10052\"><strong class=\"emphasis\">Example:<\/strong> Scanning an enrollment QR code from a letter may be bound to a flow in which the user must enter the correct username and password. This guarantees that the letter is only used by the legitimate user.<\/p><p class=\"par\" id=\"1726159367528_N10056\"><strong class=\"emphasis\">Example:<\/strong> The recovery of an authentication app (e.g. for a new phone) from a cloud backup may be bound to a flow in which the user must enter the correct username and password. This guarantees that the recovery process is initiated by a legitimate user.<\/p><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1726159367528_N10039\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Overview<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1726159367528_N1003C\">To ensure that the action (enrollment or recovery) is only possible after successfully passing an authentication flow, a so-called <i class=\"italics\">binding token<\/i> is sent from Airlock IAM to the mobile app. The <i class=\"italics\">binding token<\/i> is only sent to the mobile app if the configured authentication flow is passed and if the enrollment or recovery is verified to be for the legitimate user.<\/p><p class=\"par\" id=\"1726159367528_N10068\">The mobile app uses the <i class=\"italics\">binding token<\/i> when using the Futurae SDK to perform the enrollment or recovery. The Futurae service verifies the binding token and denies the action if the <i class=\"italics\">binding token<\/i> is not valid or missing.<\/p><p class=\"par\" id=\"1726159367528_N10071\">Consider the following flow diagram depicting the enrollment (activation) of an app with a QR-code letter using the <i class=\"italics\">Trusted Session Binding<\/i> feature.<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1726159367528_N1007E\"><img alt=\"TrustedSessionBindingWithEnrollment\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/01_Books\/Airlock_IAM_Manual\/_23Module_23\/IAM_8.3\/DOC-1458_Trusted_Session_Binding\/35168.TrustedSessionBindingWithEnrollment.theme\/1.0\/en-us.35168.TrustedSessionBindingWithEnrollment_original.svg\" style=\"width:;height:823px;border:0;\"\/><\/div><\/figure><table border=\"0\" cellspacing=\"0\" class=\"table-NoBorder table table-Nolines table-Nolines table- table-block-description table-\" id=\"1726159367528_N1009B\"><col style=\"width:5%;\"\/><col style=\"width:95%;\"\/><tbody class=\"tbody\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1726159367528_N100AD\">(1)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstrow table-cell-firstrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1726159367528_N1008D\">An enrollment QR code letter is generated and sent to the user.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1726159367528_N100C4\">(2)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1726159367528_N10093\">Within the enrollment process of the business app (e.g. e-banking app) the IAM Auth API is called to authenticate the user. This may be, for example, a username\/password check.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1726159367528_N100D01704462347664\">(3)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1726159367528_N10099\">Airlock IAM authenticates the user and keeps the user\'s identity in the session.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1726159367528_N100DF1704462347664\">(4)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1726159367528_N1009F\">The user scans the enrollment code from the letter in the business app. The business app sends the enrollment code to Airlock IAM.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1726159367528_N100F3\">(5)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1726159367528_N100A5\">Airlock IAM verifies that the enrollment code was originally issued for the user just authenticated. If so, it gets a <i class=\"italics\">binding token<\/i> from the Futurae cloud.<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-innerrow table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1726159367528_N100FF\">(6)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-even table-cell-even-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-innerrow table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1726159367528_N100AE\">Airlock IAM sends the <i class=\"italics\">binding token<\/i> to the business app which calls the SDK with the binding token (and the enrollment code).<\/p><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-firstcolumn table-cell-firstcolumn-Nolines table-cell-firstcolumn-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-col-odd-Nolines\"><div><p class=\"par\" id=\"1726159367528_N1010C1726560261957\">(7)<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-Nolines table-cell-odd table-cell-odd-Nolines table-cell-lastrow table-cell-lastrow-Nolines table-cell-lastcolumn table-cell-lastcolumn-Nolines table-cell-lastcolumn-Nolines table-cell-col-even-Nolines\"><div><p class=\"par\" id=\"1726159367528_N100B7\">The SDK in the business app sends <i class=\"italics\">the binding token<\/i> together with the enrollment code to the Futurae cloud. The Futurae cloud verifies that the <i class=\"italics\">binding token<\/i> is valid and completes the enrollment of the app.<\/p><\/div><\/td><\/tr><\/tbody><\/table><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1726159367528_N1003E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Configuration<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\">The <i class=\"italics\">Trusted Session Binding<\/i> feature can be enabled for enrollment (activation) and\/or recovery in the <span class=\"dialog\">Airlock 2FA Settings<\/span>.<\/li><li class=\"enum-element\">Depending on the use case, either an authentication flow or a protected self-service flow must be set up, and a corresponding flow step must be included. The use case examples below show what steps to use.<\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1726159367528_N100F31726553770916\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Use case 1: Recovery (Flow steps and REST call sequence)<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1726159367528_N100F6\">The recovery process allows to restore previously enrolled Airlock 2FA accounts on a fresh installation of a mobile app, e.g., when using a new mobile phone. <\/p><p class=\"par\" id=\"1726159367528_N100FB1726557260382\">Note that a physical device may contain multiple Airlock 2FA user accounts. All of them are recovered at a time, i.e., if one of the accounts to be recovered belongs to the legitimate user, a <i class=\"italics\">binding token<\/i> is issued and the recovery process for all accounts succeeds. <\/p><p class=\"par\" id=\"1726159367528_N100FB1726553770916\">If <span class=\"dialog\">Trusted Session Binding for Recovery<\/span> is enabled in the <span class=\"dialog\">Airlock 2FA Settings<\/span> use the step <span class=\"dialog\">Airlock 2FA Recovery Trusted Session Binding Step<\/span> in the authentication or protected self-service flow as indicated in the subsequent examples:<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Example 1: Authentication flow<\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Flow steps:<\/li><li class=\"enum-element\"><span class=\"dialog\">Username Password Authentication Step<\/span><\/li><li class=\"enum-element\"><span class=\"dialog\">Airlock 2FA Recovery Trusted Session Binding Step<\/span><\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">REST endpoints to call:<\/li><li class=\"enum-element\"><code class=\"codeinline\">\/rest\/public\/authentication\/password\/check\/<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">\/rest\/public\/authentication\/airlock-2fa\/recovery\/start\/<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">\/rest\/public\/authentication\/airlock-2fa\/recovery\/status\/poll\/<\/code><\/li><\/ul><\/ul><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1726159367528_N100E8\">Please refer to the step\'s plugin documentation in the Config Editor for more information.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1726159367528_N10135\">Details on the mentioned REST API endpoints can be found in the REST API specification: <a href="loginapp-rest/index.html" target="_blank">Loginapp REST API Reference</a><\/p><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Example 2: Protected self-service flow<\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Flow steps:<\/li><li class=\"enum-element\"><span class=\"dialog\">Airlock 2FA Recovery Trusted Session Binding Step<\/span><\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">REST endpoints to call:<\/li><li class=\"enum-element\"><code class=\"codeinline\">\/rest\/protected\/self-service\/airlock-2fa\/recovery\/start\/<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">\/rest\/protected\/self-service\/airlock-2fa\/recovery\/status\/poll\/<\/code><\/li><\/ul><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1726159367528_N10151\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Use case 2: Enrollment\/Activation with letter (Flow steps and REST call sequence)<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1726159367528_N10156\">If a QR code enrollment letter has been sent to the user, use the step <span class=\"dialog\">Airlock 2FA Activation Trusted Session Binding Step<\/span> to secure the process with the <i class=\"italics\">Trusted Flow Binding<\/i> feature.<\/p><p class=\"par\" id=\"1726159367528_N1015F\">In the <span class=\"dialog\">Airlock 2FA Settings<\/span>, make sure that <span class=\"dialog\">Trusted Session Binding for Activation<\/span> is either set to <span class=\"dialog\">Only with Letter<\/span> or to <span class=\"dialog\">Always<\/span>.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Example 3: Authentication flow<\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Flow steps:<\/li><li class=\"enum-element\"><span class=\"dialog\">Username Password Authentication Step<\/span><\/li><li class=\"enum-element\"><span class=\"dialog\">Airlock 2FA Activation Trusted Session Binding Step<\/span><\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">REST endpoints to call:<\/li><li class=\"enum-element\"><code class=\"codeinline\">\/rest\/public\/authentication\/password\/check\/<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">\/rest\/public\/authentication\/airlock-2fa\/activation\/start\/<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">\/rest\/public\/authentication\/airlock-2fa\/activation\/status\/poll\/<\/code><\/li><\/ul><\/ul><div xmlns=\"\" class=\"container-warning info\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/info_icon_w.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_info\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1726159367528_N10193\">Please refer to the step\'s plugin documentation in the Config Editor for more information.<\/p><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1726159367528_N10196\">Details on the mentioned REST API endpoints can be found in the REST API specification: <a href="loginapp-rest/index.html" target="_blank">Loginapp REST API Reference</a><\/p><\/div><\/div><\/div><\/div><\/div><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Example 4: Protected self-service flow:<\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Flow steps:<\/li><li class=\"enum-element\"><span class=\"dialog\">Airlock 2FA Activation Trusted Session Binding Step<\/span><\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">REST endpoints to call:<\/li><li class=\"enum-element\"><code class=\"codeinline\">\/rest\/protected\/self-service\/airlock-2fa\/activation\/start\/<\/code><\/li><li class=\"enum-element\"><code class=\"codeinline\">\/rest\/protected\/self-service\/airlock-2fa\/activation\/status\/poll\/<\/code><\/li><\/ul><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';