var m_1726159367635Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Airlock 2FA cooldown period feature<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1726159367635\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Airlock 2FA cooldown period feature<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1726159367635_N10008\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1726159367635_N10009\">Customers increasingly have to deal with fraudulent theft of credentials. Methods used are for example <i class=\"italics\">phishing<\/i>, where cybercriminals try to trick individuals into providing their credentials through fake emails, websites, or messages that appear legitimate, or <i class=\"italics\">brute force attacks<\/i>, where automated tools are used to guess passwords by systematically trying various combinations until the correct one is found.<\/p><p class=\"par\" id=\"1726159367635_N10043\">The <i class=\"italics\">cooldown period<\/i> feature represents a measure to detect and protect against credential theft. It allows defining a cooldown period for newly enrolled Airlock 2FA devices. This gives customers time to verify that the new device was registered by a real and legitimate end-user, and not by a malicious third party attempting to access the end-user\'s account with stolen end-user credentials. <\/p><p class=\"par\" id=\"1726159367635_N1001B\">If required, it is possible to allow the use of new Airlock 2FA devices for specific <i class=\"italics\">low-risk<\/i> operations during the cooldown period, such as low-value transaction approvals and authentication to unexposed applications. <\/p><p class=\"par\" id=\"1726159367635_N1002D\">Both the cooldown period itself and the allowed transactions are configurable. For more information on how to configure the cooldown period feature, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1726159375719.html\">Configuring the cooldown period<\/a>.<\/p><div xmlns=\"\" class=\"container-warning notice\"><div class=\"table-notice\"><div class=\"icon-notice\"><div class=\"container-warning-icon\"><img height=\"35\" src=\"..\/resources\/images\/notice_white.svg\" width=\"40\"\/><\/div><\/div><div class=\"content-notice\"><div class=\"warning-notice_notice\"><div class=\"warning-notice\"><p xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" class=\"par\" id=\"1726159367635_N10032\">There is also a special use case, which combines the cooldown period feature with the one-device policy. In this use case, only one valid 2FA device per end-user is allowed. For more information on how to configure this special use case, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1726159375701.html\">Cooldown period with one-device policy<\/a>.<\/p><\/div><\/div><\/div><\/div><\/div><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1726159367635_N101B3\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Event notifications on the cooldown period<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1726159367635_N101EB\">IAM provides several Airlock 2FA notifications to inform the end-user about the events that occur during the cooldown period process.<\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">There are notifications about the following events:<\/strong><\/li><li class=\"enum-element\"><i class=\"italics\">Airlock 2FA Device Activated<\/i> - This event\'s notification informs the end-user about the successful registration of the new 2FA device. <\/li><li class=\"enum-element\"><i class=\"italics\">Airlock 2FA Device In Cooldown Used<\/i> - This event\'s notification informs the end-user when they used a 2FA device that is currently in cooldown.<\/li><li class=\"enum-element\"><i class=\"italics\">Airlock 2FA Device Deleted<\/i> - This event\'s notification informs the end-user about the deletion of their \"old\" 2FA device. This notification is of relevance to the special use case, where the cooldown period feature is combined with the one-device policy.  <\/li><\/ul><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">For more information on events and notifications, see:<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1623759809565.html\">Event producers<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1623759809553.html\">Event attributes<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1623759809568.html\">Event subscribers<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1726159367635_N100FF\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">The Airlock 2FA Cooldown Information value provider<\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1726159367635_N10233\">Besides notifying the end-user, it is also possible to inform the <i class=\"italics\">backend application<\/i> about the cooldown status of the used Airlock 2FA device. This happens with the value provider <i class=\"italics\">Airlock 2FA Cooldown Information<\/i>.  Based on the information provided by this value provider, the backend application may, e.g., block specific operations for the device in cooldown, but allow these operations for devices that are active and outside the cooldown period. <\/p><p class=\"par\" id=\"1726159367635_N10247\">The <i class=\"italics\">Airlock 2FA Cooldown Information<\/i> value provider provides the following keys:<\/p><table border=\"0\" cellspacing=\"0\" class=\"table table table-BoldHeader table-BoldHeader table- table-block-description table-\" id=\"1726159367635_N1024C\"><col style=\"width:33%;\"\/><col style=\"width:33%;\"\/><col style=\"width:34%;\"\/><thead class=\"thead-BoldHeader\"><tr class=\"table-row\"><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1726159367635_N102621726756710886\">Key<\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-header table-header-horizontal table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1726159367635_N10267\">Description <\/p><\/div><\/th><th class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstrow table-cell-firstrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-header table-header-horizontal table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1726159367635_N1026C\">Values<\/p><\/div><\/th><\/tr><\/thead><tbody class=\"tbody-BoldHeader\"><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1726159367635_N1027E\"><code class=\"codeinline\">a2fa-cooldown-auth-device<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1726159367635_N102861726756852271\">Reports whether the Airlock 2FA token used for authentication is in cooldown.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><code class=\"codeinline\">cooldown<\/code>: The device is in cooldown.<\/li><li class=\"enum-element\"><code class=\"codeinline\">active<\/code>: The device is out of the cooldown period and fully active.<\/li><\/ul><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1726159367635_N102901726757631098\"><code class=\"codeinline\">a2fa-cooldown-ends<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-innerrow table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1726159367635_N10296\">Delivers the point in time when the cooldown period will end for the Airlock 2FA token used for authentication. If this token is out of the cooldown period and active, the key is not supplied.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-odd table-cell-odd-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-innerrow table-cell-col-odd-BoldHeader\"><div><ul class=\"enum-enum-instruction container-enum enum-standard standard first last\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Example values:<\/li><li class=\"enum-element\">2011-12-03T10:15:30.000+01:00<\/li><li class=\"enum-element\">2018-02-06T15:58:53.661Z<\/li><\/ul><\/div><\/td><\/tr><tr class=\"table-row\"><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-firstcolumn table-cell-firstcolumn-BoldHeader table-cell-firstcolumn-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-col-odd-BoldHeader\"><div><p class=\"par\" id=\"1726159367635_N102A8\"><code class=\"codeinline\">a2fa-cooldown-devices<\/code><\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-innercol table-cell-col-even-BoldHeader\"><div><p class=\"par\" id=\"1726159367635_N102AD\">Informs about the cooldown status of Airlock 2FA devices of the end-user.<\/p><\/div><\/td><td class=\"table-cell table-cell table-cell-BoldHeader table-cell-even table-cell-even-BoldHeader table-cell-lastrow table-cell-lastrow-BoldHeader table-cell-lastcolumn table-cell-lastcolumn-BoldHeader table-cell-lastcolumn-BoldHeader table-cell-col-odd-BoldHeader\"><div><ul class=\"enum-enum-instruction container-enum enum-standard fixedStart-1 standard first last\" start=\"1\" style=\"--lastC:0\"><li class=\"enum-element\"><code class=\"codeinline\">has_active<\/code>: There is at least one Airlock 2FA device that is active and not in cooldown.<\/li><li class=\"enum-element\"><code class=\"codeinline\">all_cooldown<\/code>: All available Airlock 2FA devices are in cooldown.<\/li><li class=\"enum-element\"><code class=\"codeinline\">none<\/code>: There are no Airlock 2FA devices at all.<\/li><\/ul><\/div><\/td><\/tr><\/tbody><\/table><p class=\"par\" id=\"1726159367635_N102B4\"><strong class=\"emphasis\">Configuring the <i class=\"italics\">Airlock 2FA Cooldown Information<\/i> value provider<\/strong><\/p><p class=\"par\" id=\"1726159367635_N102F9\">The <i class=\"italics\">Airlock 2FA Cooldown Information<\/i> value provider can be configured in several locations within the Config Editor. One important way in this context is in combination with the <i class=\"italics\">Identity Propagation<\/i> plugin. This plugin is used to provide information about an authenticated end-user to the backend application. <\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">To provide cooldown information to the backend application with the <i class=\"italics\">Identity Propagation<\/i> plugin, proceed as follows:<\/li><li class=\"step\">Go to<br\/><span class=\"dialog\">Loginapp &gt;&gt; Applications and Authentication &gt;&gt; <i class=\"italics\">&lt;your application&gt;<\/i><\/span><\/li><li class=\"step\">In property <span class=\"dialog\">Identity Propagation<\/span>, create and edit a <span class=\"dialog\">Generic ID Propagator<\/span> plugin, as follows:<\/li><li class=\"step\">In property <span class=\"dialog\">Ticket String Provider<\/span> of the <span class=\"dialog\">Generic ID Propagator<\/span> plugin, create and edit a <span class=\"dialog\">Ticket String Provider<\/span> plugin. Based on a list of value providers, this plugin creates a structured ticket (basically a list of key-value pairs) and encodes them in a JWT. To provide cooldown information, add the <span class=\"dialog\">Airlock 2FA Cooldown Information<\/span> plugin to the <span class=\"dialog\">Value Providers<\/span> list of the <span class=\"dialog\">Ticket String Provider<\/span> plugin.<\/li><li class=\"step\">To configure all other settings of the <span class=\"dialog\">Generic ID Propagator<\/span>, see <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1632211986856.html\">The Generic ID Propagator plugin<\/a>.<\/li><li class=\"step\">Activate your configuration.<\/li><li class=\"step result\">You have now configured an identity propagator that provides the backend application with information about the cooldown status of the used Airlock 2FA device.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1726159367635_N1008E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Internal links:<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1726159375719.html\">Configuring the cooldown period<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1726159375701.html\">Cooldown period with one-device policy<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1623759809565.html\">Event producers<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1623759809553.html\">Event attributes<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1623759809568.html\">Event subscribers<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1631819651210.html\">Identity propagation<\/a><\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1632211986856.html\">The Generic ID Propagator plugin<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';