var m_1726159375701Xml = '<html xmlns=\"http:\/\/www.w3.org\/1999\/xhtml\" lang=\"en-us\" xml:lang=\"en-us\"><head><meta content=\"IE=EDGE\" http-equiv=\"x-ua-compatible\"\/><meta charset=\"UTF-8\"\/><meta content=\"width=device-width, initial-scale=1.0\" name=\"viewport\"\/><title>Cooldown period with one-device policy<\/title><link href=\"..\/resources\/css\/preview.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/styles.css\" rel=\"stylesheet\" type=\"text\/css\"\/><link href=\"..\/resources\/css\/custom-style.css\" rel=\"stylesheet\" type=\"text\/css\"\/><\/head><body class=\"language-en-us online-help\"><header class=\"header\"><div class=\"header-ct\"><nav class=\"main-nav\"><div class=\"nav-ct\"><a class=\"nav-logo\" href=\"..\/index.html\"><\/a><\/div><\/nav><\/div><\/header><section class=\"section\" id=\"1726159375701\"><div class=\" section-inner-ct\"><header class=\"section-header\"><div class=\" headline-content-ct\"><div class=\" headline-content-content\"><h1 class=\"headline-content\">Cooldown period with one-device policy<\/h1><\/div><\/div><\/header><div id=\"section-column-main-content\"><div class=\" block-ct\"><article class=\"block-description\" id=\"1726159375701_N10121\"><div class=\" block-inner-ct\"><div class=\" block-content-ct\"><p class=\"par\" id=\"1726159375701_N10124\">This article explains how to configure the cooldown period feature combined with the one-device policy (short: CPOD), where only one valid 2FA device per end-user is allowed. If an end-user with an valid 2FA device enrolls a second device, the \"old\" device is deleted. When this happens, depends on the rigidness of the rule. <\/p><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">There are two implementations:<\/strong><\/li><li class=\"enum-element\"><i class=\"italics\">Lenient<\/i>: In this case, the end-user may use the \"old\" 2FA device until the newly enrolled 2FA device is out of the cooldown period.<\/li><li class=\"enum-element\"><i class=\"italics\">Strict<\/i>: Here, the end-user may only have one valid 2FA device at <i class=\"italics\">any<\/i> time. Upon enrollment of a new 2FA device, the old 2FA device is deleted. <\/li><\/ul><p class=\"par\" id=\"1726159375701_N1012A\"> See below for a graphical representation of the <i class=\"italics\">lenient<\/i> implementation:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1726159375701_N10130\"><img alt=\"Airlock2FA-cooldownperiod_onetouch-lenient\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/05_Media\/Vector_drawings\/Airlock_2FA\/35170.Airlock2FA-cooldownperiod_onetouch-lenient.theme\/1.1\/en-us.35170.Airlock2FA-cooldownperiod_onetouch-lenient_original.svg\" style=\"width:;height:377px;border:0;\"\/><\/div><\/figure><p class=\"par\" id=\"1726159375701_N1013A1727096138477\"> See below for a graphical representation of the <i class=\"italics\">strict<\/i> implementation:<\/p><figure class=\"media\"><div class=\"media-theme\" id=\"1726159375701_N1013E\"><img alt=\"Airlock2FA-cooldownperiod_onetouch-strict\" class=\"media-theme-img-tag drawio\" src=\"..\/media\/05_Media\/Vector_drawings\/Airlock_2FA\/35171.Airlock2FA-cooldownperiod_onetouch-strict.theme\/1.1\/en-us.35171.Airlock2FA-cooldownperiod_onetouch-strict_original.svg\" style=\"width:;height:377px;border:0;\"\/><\/div><\/figure><p class=\"par\" id=\"1726159375701_N1013A\">To implement this use case, first specify the general cooldown settings. Then, add a <i class=\"italics\">Airlock 2FA Delete Devices Step<\/i>. This step deletes the old device so that there is only one valid 2FA device, namely the newly registered device. Where to add this step in the flow and which device(s) to delete depends on the implemented variant (strict or lenient).<\/p><p class=\"par\" id=\"1726159375701_N1017A\"><i class=\"italics\"><strong class=\"emphasis\">Configuring CPOD - Strict implementation<\/strong><\/i><\/p><p class=\"par\" id=\"1726159375701_N1017E\">In the CPOD-strict implementation, only one valid 2FA device is allowed per end-user at a time. This means that the \"old\" device will be deleted as soon as the new 2FA device is enrolled\/registered. To implement this use case, add a <i class=\"italics\">Airlock 2FA Delete Devices Step<\/i> <i class=\"italics\"><strong class=\"emphasis\">after<\/strong><\/i> the <i class=\"italics\">Airlock 2FA Activation Step<\/i>. The activation step appears in all subflows where a new Airlock 2FA device can be registered, e.g., in the <i class=\"italics\">Migration to Airlock 2FA<\/i> subflow of an authentication flow, or in the <i class=\"italics\">Airlock 2FA Activate App Device<\/i> subflow as part of protected self services.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Proceed as follows:<\/strong><\/li><li class=\"step\">First, configure the cooldown period, as described in <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1726159375719.html\">Configuring the cooldown period<\/a>.<\/li><li class=\"step\">Then go to the relevant subflow, and open the plugin dialog in which the steps of the subflow are specified.<\/li><li class=\"step\">In the corresponding dialog, in the <span class=\"dialog\">Steps<\/span> list, create an <span class=\"dialog\">Airlock 2FA Delete Devices Step<\/span>. It should come <i class=\"italics\"><strong class=\"emphasis\">after <\/strong><\/i>the <span class=\"dialog\">Airlock 2FA Activation Step<\/span>.<\/li><li class=\"step\">Edit the <span class=\"dialog\">Airlock 2FA Delete Devices Step<\/span> plugin as follows:<\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span>, property <span class=\"dialog\">Devices to Delete<\/span>, select the <span class=\"dialog\">All Devices Except Most Recently Registered<\/span> option. Edit the option as follows:<\/li><li class=\"step\">Disable the <span class=\"dialog\">Respect Cooldown Period<\/span> property.<\/li><li class=\"step\">Leave all other default settings as they are.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">This is why:<\/strong><\/li><li class=\"enum-element\">Upon registering a new 2FA device, the system will check all 2FA devices of the end-user in order to keep only the most recently registered device. Because cooldown is <strong class=\"emphasis\">not<\/strong> respected, the system also considers the newly registered device for its check. As this device is the most recently registered one, the system will delete all other devices. As a consequence, the end-user now has just one valid device left, which is currently in cooldown.<\/li><\/ul><li class=\"step\">Activate your configuration. <\/li><li class=\"step result\">You have now configured a cooldown period combined with a one-device policy, in the strict implementation.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1726159375701_N100B6\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><strong class=\"emphasis\">Configuring CPOD - Lenient implementation<\/strong><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1726159375701_N10143\">In the CPOD-lenient implementation, the end-user may still use the \"old\" 2FA device as long as the newly registered device is in cooldown. However, the old device is deleted the first time the user uses the new device after cooldown. To implement this use case, add an <i class=\"italics\">Airlock 2FA Delete Devices Step<\/i> <i class=\"italics\"><strong class=\"emphasis\">before<\/strong><\/i> the <i class=\"italics\">Airlock 2FA Authentication Step<\/i>, in the Airlock 2FA second factor subflow of an authentication flow. <\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Proceed as follows:<\/strong><\/li><li class=\"step\">First, configure the cooldown period, as described in  in <a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1726159375719.html\">Configuring the cooldown period<\/a>.<\/li><li class=\"step\">Then go to the Airlock 2FA second factor subflow, and open the plugin dialog in which the steps of the subflow are specified.<\/li><li class=\"step\">In the <span class=\"dialog\">Steps<\/span> list, create an <span class=\"dialog\">Airlock 2FA Delete Devices Step<\/span>. It should come <i class=\"italics\"><strong class=\"emphasis\">before<\/strong><\/i> the <span class=\"dialog\">Airlock 2FA Authentication Step<\/span>.<\/li><li class=\"step\">Edit the <span class=\"dialog\">Airlock 2FA Delete Devices Step<\/span> plugin as follows:<\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span>, property <span class=\"dialog\">Devices to Delete<\/span>, select the <span class=\"dialog\">All Devices Except Most Recently Registered<\/span> option. Do <strong class=\"emphasis\">not<\/strong> change the default settings (i.e., the  <span class=\"dialog\">Respect Cooldown Period<\/span> property must remain enabled).<\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">This is why:<\/strong><\/li><li class=\"enum-element\">If the end-user uses the old device during the cooldown period, the system will check the 2FA devices of the end-user in order to keep only the most recent registered device, which is the new one. However, because the new device is in cooldown and cooldown is respected, the system does not consider the new device for its check. In the perception of the system, the old device is still the most recently registered device. It is thus not deleted.<\/li><li class=\"enum-element\">As soon as the new device is out of cooldown and active, it is included in the system\'s check of end-user devices. Upon first use of the new 2FA device after cooldown, the system now counts two active 2FA devices. It will delete the old one and keep the new one, as this is the most-recently registered device.<\/li><\/ul><li class=\"step\">Activate your configuration. <\/li><li class=\"step result\">You have now configured a cooldown period combined with a one-device policy, in the lenient implementation.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1726159375701_N1010E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\"><strong class=\"emphasis\">Configuring CPOD - Strict implementation<\/strong><\/h2><\/div><\/header><div class=\" block-content-ct\"><p class=\"par\" id=\"1726159375701_N10113\">In the CPOD-strict implementation, only one valid 2FA device is allowed per end-user at a time. This means that the \"old\" device will be deleted as soon as the new 2FA device is enrolled\/registered. To implement this use case, add a <i class=\"italics\">Airlock 2FA Delete Devices Step<\/i> <i class=\"italics\"><strong class=\"emphasis\">after<\/strong><\/i> the <i class=\"italics\">Airlock 2FA Activation Step<\/i>. The activation step appears in all subflows where a new Airlock 2FA device can be registered, e.g., in the <i class=\"italics\">Migration to Airlock 2FA<\/i> subflow of an authentication flow, or in the <i class=\"italics\">Airlock 2FA Activate App Device<\/i> subflow as part of protected self services.<\/p><ol class=\"enum-enum-instruction container-enum instruction standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">Proceed as follows:<\/strong><\/li><li class=\"step\">First, configure the cooldown period, as described in the general use case above.<\/li><li class=\"step\">Then go to the relevant subflow, and open the plugin dialog in which the steps of the subflow are specified.<\/li><li class=\"step\">In the corresponding dialog, in the <span class=\"dialog\">Steps<\/span> list, create an <span class=\"dialog\">Airlock 2FA Delete Devices Step<\/span>. It should come <i class=\"italics\"><strong class=\"emphasis\">after <\/strong><\/i>the <span class=\"dialog\">Airlock 2FA Activation Step<\/span>.<\/li><li class=\"step\">Edit the <span class=\"dialog\">Airlock 2FA Delete Devices Step<\/span> plugin as follows:<\/li><li class=\"step\">In section <span class=\"dialog\">Basic Settings<\/span>, property <span class=\"dialog\">Devices to Delete<\/span>, select the <span class=\"dialog\">All Devices Except Most Recently Registered<\/span> option. Edit the option as follows:<\/li><li class=\"step\">Disable the <span class=\"dialog\">Respect Cooldown Period<\/span> property.<\/li><li class=\"step\">Leave all other default settings as they are.<\/li><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\"><strong class=\"emphasis\">This is why:<\/strong><\/li><li class=\"enum-element\">Upon registering a new 2FA device, the system will check all 2FA devices of the end-user in order to keep only the most recently registered device. Because cooldown is <strong class=\"emphasis\">not<\/strong> respected, the system also considers the newly registered device for its check. As this device is the most recently registered one, the system will delete all other devices. As a consequence, the end-user now has just one valid device left, which is currently in cooldown.<\/li><\/ul><li class=\"step\">Activate your configuration. <\/li><li class=\"step result\">You have now configured a cooldown period combined with a one-device policy, in the strict implementation.<\/li><\/ol><\/div><\/div><\/article><\/div><div class=\" block-ct\"><article class=\"block-description\" id=\"1726159375701_N1008E\"><div class=\" block-inner-ct\"><header class=\" label  label-block-description\"><div class=\" label-content  label-content-block-description\"><h2 class=\"label-title label-title-block-description\">Further information and links<\/h2><\/div><\/header><div class=\" block-content-ct\"><ul class=\"enum-enum-instruction container-enum enum-standard standard\" start=\"0\" style=\"--lastC:0\"><li class=\"enum-title\">Internal links:<\/li><li class=\"enum-element\"><a xmlns:svg=\"http:\/\/www.w3.org\/2000\/svg\" class=\"link link-xref\" href=\"data\/1726159375719.html\">Configuring the cooldown period<\/a><\/li><\/ul><\/div><\/div><\/article><\/div><\/div><\/div><\/section><script language=\"javascript\" src=\"..\/resources\/js\/jquery.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/SearchHighlight.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/html5-script.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/custom.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery.browser.js\" type=\"text\/javascript\"><\/script><script language=\"javascript\" src=\"..\/resources\/js\/jquery-iframe-auto-height.js\" type=\"text\/javascript\"><\/script><\/body><\/html>';